# Fiacre Simulator

The Fiacre Simulator is an Eclipse based project supporting the edition,
debugging and animation of formal models written in Fiacre.

Besides the capabilities of a XText plugin, such as syntax-highlighting, the
Fiacre Simulator includes _LibTTS_, a thrift-based server that can interface
with a _TTS player_ (an animator for Fiacre models). It also includes a library
for generating _Message Sequence Charts_ representation from execution traces
collected during a simulation.

You can visit the [Fiacre project website](http://projects.laas.fr/fiacre/) for
more information about the language.

## How to install the Fiacre Simulator

We assume that you already installed the Fiacre complier,
[frac](http://projects.laas.fr/fiacre/download.php), as well as a C compiler.

The plugin is compatible with Eclipse Neon (with the modeling framework) and is
based on Xtext 2.10.

## Organization of the files

## License

The Fiacre simulator is copyright 2015-2017 CNRS, IRIT, and IRT Saint Exupéry.
All rights reserved. It is distributed under the terms of the LGPL 3.0 license,
see [the LICENSES file](./LICENSES.md).

## Reference

More information about the plugin can be found in the following publication.

* [Model Execution and Debugging: A process to leverage existing
  Tools](http://oatao.univ-toulouse.fr/18236/) Zalila, Faiez and Jenn, Eric and
  Pantel, Marc. In Proc. of ModelsWard, _5th International Conference on
  Model-Driven Engineering and Software Development_, 2017.