/*******************************************************************************
 * Copyright (c) 2015, 2016 CNRS, IRIT, IRT AESE (IRT Saint Exupéry).
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the LGPL 3.0
 * which accompanies this distribution, and is available at
 * https://www.gnu.org/licenses/lgpl-3.0-standalone.html
 *
 * Contributors:
 *     Faiez Zalila - initial API and implementation and/or initial documentation
 *******************************************************************************/
/**
 */
package com.irtsaintexupery.fiacre.instance.fiacreinstance;

import fr.irit.fiacre.xtext.fiacre.ComponentInstance;

import org.eclipse.emf.common.util.EList;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Declaration Instance</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link com.irtsaintexupery.fiacre.instance.fiacreinstance.DeclarationInstance#getVariableDeclarationInstances <em>Variable Declaration Instances</em>}</li>
 *   <li>{@link com.irtsaintexupery.fiacre.instance.fiacreinstance.DeclarationInstance#getName <em>Name</em>}</li>
 *   <li>{@link com.irtsaintexupery.fiacre.instance.fiacreinstance.DeclarationInstance#getInstance <em>Instance</em>}</li>
 *   <li>{@link com.irtsaintexupery.fiacre.instance.fiacreinstance.DeclarationInstance#getFlatname <em>Flatname</em>}</li>
 * </ul>
 *
 * @see com.irtsaintexupery.fiacre.instance.fiacreinstance.FiacreinstancePackage#getDeclarationInstance()
 * @model abstract="true"
 * @generated
 */
public interface DeclarationInstance extends BlockInstance {
	/**
	 * Returns the value of the '<em><b>Variable Declaration Instances</b></em>' containment reference list.
	 * The list contents are of type {@link com.irtsaintexupery.fiacre.instance.fiacreinstance.VariableDeclarationInstance}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Variable Declaration Instances</em>' containment reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Variable Declaration Instances</em>' containment reference list.
	 * @see com.irtsaintexupery.fiacre.instance.fiacreinstance.FiacreinstancePackage#getDeclarationInstance_VariableDeclarationInstances()
	 * @model containment="true"
	 * @generated
	 */
	EList<VariableDeclarationInstance> getVariableDeclarationInstances();

	/**
	 * Returns the value of the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Name</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Name</em>' attribute.
	 * @see #setName(String)
	 * @see com.irtsaintexupery.fiacre.instance.fiacreinstance.FiacreinstancePackage#getDeclarationInstance_Name()
	 * @model required="true"
	 * @generated
	 */
	String getName();

	/**
	 * Sets the value of the '{@link com.irtsaintexupery.fiacre.instance.fiacreinstance.DeclarationInstance#getName <em>Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Name</em>' attribute.
	 * @see #getName()
	 * @generated
	 */
	void setName(String value);

	/**
	 * Returns the value of the '<em><b>Instance</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Instance</em>' reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Instance</em>' reference.
	 * @see #setInstance(ComponentInstance)
	 * @see com.irtsaintexupery.fiacre.instance.fiacreinstance.FiacreinstancePackage#getDeclarationInstance_Instance()
	 * @model
	 * @generated
	 */
	ComponentInstance getInstance();

	/**
	 * Sets the value of the '{@link com.irtsaintexupery.fiacre.instance.fiacreinstance.DeclarationInstance#getInstance <em>Instance</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Instance</em>' reference.
	 * @see #getInstance()
	 * @generated
	 */
	void setInstance(ComponentInstance value);

	/**
	 * Returns the value of the '<em><b>Flatname</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Flatname</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Flatname</em>' attribute.
	 * @see #setFlatname(String)
	 * @see com.irtsaintexupery.fiacre.instance.fiacreinstance.FiacreinstancePackage#getDeclarationInstance_Flatname()
	 * @model
	 * @generated
	 */
	String getFlatname();

	/**
	 * Sets the value of the '{@link com.irtsaintexupery.fiacre.instance.fiacreinstance.DeclarationInstance#getFlatname <em>Flatname</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Flatname</em>' attribute.
	 * @see #getFlatname()
	 * @generated
	 */
	void setFlatname(String value);

} // DeclarationInstance
