/*******************************************************************************
 * Copyright (c) 2015, 2016 CNRS, IRIT, IRT AESE (IRT Saint Exupéry).
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the LGPL 3.0
 * which accompanies this distribution, and is available at
 * https://www.gnu.org/licenses/lgpl-3.0-standalone.html
 *
 * Contributors:
 *     Faiez Zalila - initial API and implementation and/or initial documentation
 *******************************************************************************/
/**
 */
package com.irtsaintexupery.fiacre.instance.fiacreinstance;

import org.eclipse.emf.ecore.EFactory;

/**
 * <!-- begin-user-doc -->
 * The <b>Factory</b> for the model.
 * It provides a create method for each non-abstract class of the model.
 * <!-- end-user-doc -->
 * @see com.irtsaintexupery.fiacre.instance.fiacreinstance.FiacreinstancePackage
 * @generated
 */
public interface FiacreinstanceFactory extends EFactory {
	/**
	 * The singleton instance of the factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	FiacreinstanceFactory eINSTANCE = com.irtsaintexupery.fiacre.instance.fiacreinstance.impl.FiacreinstanceFactoryImpl.init();

	/**
	 * Returns a new object of class '<em>Instance Model</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Instance Model</em>'.
	 * @generated
	 */
	InstanceModel createInstanceModel();

	/**
	 * Returns a new object of class '<em>Executed Statement Block</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Executed Statement Block</em>'.
	 * @generated
	 */
	ExecutedStatementBlock createExecutedStatementBlock();

	/**
	 * Returns a new object of class '<em>Executable Statement Block</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Executable Statement Block</em>'.
	 * @generated
	 */
	ExecutableStatementBlock createExecutableStatementBlock();

	/**
	 * Returns a new object of class '<em>Fireable Statement Block</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Fireable Statement Block</em>'.
	 * @generated
	 */
	FireableStatementBlock createFireableStatementBlock();

	/**
	 * Returns a new object of class '<em>Enabled Statement Block</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Enabled Statement Block</em>'.
	 * @generated
	 */
	EnabledStatementBlock createEnabledStatementBlock();

	/**
	 * Returns a new object of class '<em>Composition Instance</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Composition Instance</em>'.
	 * @generated
	 */
	CompositionInstance createCompositionInstance();

	/**
	 * Returns a new object of class '<em>Component Declaration Instance</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Component Declaration Instance</em>'.
	 * @generated
	 */
	ComponentDeclarationInstance createComponentDeclarationInstance();

	/**
	 * Returns a new object of class '<em>Process Declaration Instance</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Process Declaration Instance</em>'.
	 * @generated
	 */
	ProcessDeclarationInstance createProcessDeclarationInstance();

	/**
	 * Returns a new object of class '<em>Instance Executed Statement Block</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Instance Executed Statement Block</em>'.
	 * @generated
	 */
	InstanceExecutedStatementBlock createInstanceExecutedStatementBlock();

	/**
	 * Returns a new object of class '<em>Instance Fireable Statement Block</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Instance Fireable Statement Block</em>'.
	 * @generated
	 */
	InstanceFireableStatementBlock createInstanceFireableStatementBlock();

	/**
	 * Returns a new object of class '<em>Instance Enabled Statement Block</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Instance Enabled Statement Block</em>'.
	 * @generated
	 */
	InstanceEnabledStatementBlock createInstanceEnabledStatementBlock();

	/**
	 * Returns a new object of class '<em>Variable Declaration Instance</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Variable Declaration Instance</em>'.
	 * @generated
	 */
	VariableDeclarationInstance createVariableDeclarationInstance();

	/**
	 * Returns the package supported by this factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the package supported by this factory.
	 * @generated
	 */
	FiacreinstancePackage getFiacreinstancePackage();

} //FiacreinstanceFactory
