/*******************************************************************************
 * Copyright (c) 2015, 2016 CNRS, IRIT, IRT AESE (IRT Saint Exupéry).
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the LGPL 3.0
 * which accompanies this distribution, and is available at
 * https://www.gnu.org/licenses/lgpl-3.0-standalone.html
 *
 * Contributors:
 *     Faiez Zalila - initial API and implementation and/or initial documentation
 *******************************************************************************/
/**
 */
package com.irtsaintexupery.fiacre.instance.fiacreinstance;

import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.EReference;

/**
 * <!-- begin-user-doc -->
 * The <b>Package</b> for the model.
 * It contains accessors for the meta objects to represent
 * <ul>
 *   <li>each class,</li>
 *   <li>each feature of each class,</li>
 *   <li>each operation of each class,</li>
 *   <li>each enum,</li>
 *   <li>and each data type</li>
 * </ul>
 * <!-- end-user-doc -->
 * @see com.irtsaintexupery.fiacre.instance.fiacreinstance.FiacreinstanceFactory
 * @model kind="package"
 * @generated
 */
public interface FiacreinstancePackage extends EPackage {
	/**
	 * The package name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNAME = "fiacreinstance";

	/**
	 * The package namespace URI.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_URI = "http://fiacreinstance/1.0";

	/**
	 * The package namespace name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_PREFIX = "fiacreinstance";

	/**
	 * The singleton instance of the package.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	FiacreinstancePackage eINSTANCE = com.irtsaintexupery.fiacre.instance.fiacreinstance.impl.FiacreinstancePackageImpl.init();

	/**
	 * The meta object id for the '{@link com.irtsaintexupery.fiacre.instance.fiacreinstance.impl.InstanceModelImpl <em>Instance Model</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.irtsaintexupery.fiacre.instance.fiacreinstance.impl.InstanceModelImpl
	 * @see com.irtsaintexupery.fiacre.instance.fiacreinstance.impl.FiacreinstancePackageImpl#getInstanceModel()
	 * @generated
	 */
	int INSTANCE_MODEL = 0;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INSTANCE_MODEL__NAME = 0;

	/**
	 * The feature id for the '<em><b>Model</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INSTANCE_MODEL__MODEL = 1;

	/**
	 * The feature id for the '<em><b>Instance</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INSTANCE_MODEL__INSTANCE = 2;

	/**
	 * The feature id for the '<em><b>Statement Blocks</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INSTANCE_MODEL__STATEMENT_BLOCKS = 3;

	/**
	 * The number of structural features of the '<em>Instance Model</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INSTANCE_MODEL_FEATURE_COUNT = 4;

	/**
	 * The number of operations of the '<em>Instance Model</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INSTANCE_MODEL_OPERATION_COUNT = 0;

	/**
	 * The meta object id for the '{@link com.irtsaintexupery.fiacre.instance.fiacreinstance.impl.StatementBlockImpl <em>Statement Block</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.irtsaintexupery.fiacre.instance.fiacreinstance.impl.StatementBlockImpl
	 * @see com.irtsaintexupery.fiacre.instance.fiacreinstance.impl.FiacreinstancePackageImpl#getStatementBlock()
	 * @generated
	 */
	int STATEMENT_BLOCK = 1;

	/**
	 * The feature id for the '<em><b>Instance Statement Blocks</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STATEMENT_BLOCK__INSTANCE_STATEMENT_BLOCKS = 0;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STATEMENT_BLOCK__NAME = 1;

	/**
	 * The number of structural features of the '<em>Statement Block</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STATEMENT_BLOCK_FEATURE_COUNT = 2;

	/**
	 * The number of operations of the '<em>Statement Block</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STATEMENT_BLOCK_OPERATION_COUNT = 0;

	/**
	 * The meta object id for the '{@link com.irtsaintexupery.fiacre.instance.fiacreinstance.impl.ExecutedStatementBlockImpl <em>Executed Statement Block</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.irtsaintexupery.fiacre.instance.fiacreinstance.impl.ExecutedStatementBlockImpl
	 * @see com.irtsaintexupery.fiacre.instance.fiacreinstance.impl.FiacreinstancePackageImpl#getExecutedStatementBlock()
	 * @generated
	 */
	int EXECUTED_STATEMENT_BLOCK = 2;

	/**
	 * The feature id for the '<em><b>Instance Statement Blocks</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXECUTED_STATEMENT_BLOCK__INSTANCE_STATEMENT_BLOCKS = STATEMENT_BLOCK__INSTANCE_STATEMENT_BLOCKS;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXECUTED_STATEMENT_BLOCK__NAME = STATEMENT_BLOCK__NAME;

	/**
	 * The number of structural features of the '<em>Executed Statement Block</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXECUTED_STATEMENT_BLOCK_FEATURE_COUNT = STATEMENT_BLOCK_FEATURE_COUNT + 0;

	/**
	 * The number of operations of the '<em>Executed Statement Block</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXECUTED_STATEMENT_BLOCK_OPERATION_COUNT = STATEMENT_BLOCK_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.irtsaintexupery.fiacre.instance.fiacreinstance.impl.ExecutableStatementBlockImpl <em>Executable Statement Block</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.irtsaintexupery.fiacre.instance.fiacreinstance.impl.ExecutableStatementBlockImpl
	 * @see com.irtsaintexupery.fiacre.instance.fiacreinstance.impl.FiacreinstancePackageImpl#getExecutableStatementBlock()
	 * @generated
	 */
	int EXECUTABLE_STATEMENT_BLOCK = 3;

	/**
	 * The feature id for the '<em><b>Instance Statement Blocks</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXECUTABLE_STATEMENT_BLOCK__INSTANCE_STATEMENT_BLOCKS = STATEMENT_BLOCK__INSTANCE_STATEMENT_BLOCKS;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXECUTABLE_STATEMENT_BLOCK__NAME = STATEMENT_BLOCK__NAME;

	/**
	 * The feature id for the '<em><b>Date</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXECUTABLE_STATEMENT_BLOCK__DATE = STATEMENT_BLOCK_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Executable Statement Block</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXECUTABLE_STATEMENT_BLOCK_FEATURE_COUNT = STATEMENT_BLOCK_FEATURE_COUNT + 1;

	/**
	 * The number of operations of the '<em>Executable Statement Block</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXECUTABLE_STATEMENT_BLOCK_OPERATION_COUNT = STATEMENT_BLOCK_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.irtsaintexupery.fiacre.instance.fiacreinstance.impl.FireableStatementBlockImpl <em>Fireable Statement Block</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.irtsaintexupery.fiacre.instance.fiacreinstance.impl.FireableStatementBlockImpl
	 * @see com.irtsaintexupery.fiacre.instance.fiacreinstance.impl.FiacreinstancePackageImpl#getFireableStatementBlock()
	 * @generated
	 */
	int FIREABLE_STATEMENT_BLOCK = 4;

	/**
	 * The feature id for the '<em><b>Instance Statement Blocks</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FIREABLE_STATEMENT_BLOCK__INSTANCE_STATEMENT_BLOCKS = EXECUTABLE_STATEMENT_BLOCK__INSTANCE_STATEMENT_BLOCKS;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FIREABLE_STATEMENT_BLOCK__NAME = EXECUTABLE_STATEMENT_BLOCK__NAME;

	/**
	 * The feature id for the '<em><b>Date</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FIREABLE_STATEMENT_BLOCK__DATE = EXECUTABLE_STATEMENT_BLOCK__DATE;

	/**
	 * The number of structural features of the '<em>Fireable Statement Block</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FIREABLE_STATEMENT_BLOCK_FEATURE_COUNT = EXECUTABLE_STATEMENT_BLOCK_FEATURE_COUNT + 0;

	/**
	 * The number of operations of the '<em>Fireable Statement Block</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FIREABLE_STATEMENT_BLOCK_OPERATION_COUNT = EXECUTABLE_STATEMENT_BLOCK_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.irtsaintexupery.fiacre.instance.fiacreinstance.impl.EnabledStatementBlockImpl <em>Enabled Statement Block</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.irtsaintexupery.fiacre.instance.fiacreinstance.impl.EnabledStatementBlockImpl
	 * @see com.irtsaintexupery.fiacre.instance.fiacreinstance.impl.FiacreinstancePackageImpl#getEnabledStatementBlock()
	 * @generated
	 */
	int ENABLED_STATEMENT_BLOCK = 5;

	/**
	 * The feature id for the '<em><b>Instance Statement Blocks</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENABLED_STATEMENT_BLOCK__INSTANCE_STATEMENT_BLOCKS = EXECUTABLE_STATEMENT_BLOCK__INSTANCE_STATEMENT_BLOCKS;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENABLED_STATEMENT_BLOCK__NAME = EXECUTABLE_STATEMENT_BLOCK__NAME;

	/**
	 * The feature id for the '<em><b>Date</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENABLED_STATEMENT_BLOCK__DATE = EXECUTABLE_STATEMENT_BLOCK__DATE;

	/**
	 * The number of structural features of the '<em>Enabled Statement Block</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENABLED_STATEMENT_BLOCK_FEATURE_COUNT = EXECUTABLE_STATEMENT_BLOCK_FEATURE_COUNT + 0;

	/**
	 * The number of operations of the '<em>Enabled Statement Block</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENABLED_STATEMENT_BLOCK_OPERATION_COUNT = EXECUTABLE_STATEMENT_BLOCK_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.irtsaintexupery.fiacre.instance.fiacreinstance.impl.BlockInstanceImpl <em>Block Instance</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.irtsaintexupery.fiacre.instance.fiacreinstance.impl.BlockInstanceImpl
	 * @see com.irtsaintexupery.fiacre.instance.fiacreinstance.impl.FiacreinstancePackageImpl#getBlockInstance()
	 * @generated
	 */
	int BLOCK_INSTANCE = 6;

	/**
	 * The feature id for the '<em><b>Block Instances</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BLOCK_INSTANCE__BLOCK_INSTANCES = 0;

	/**
	 * The number of structural features of the '<em>Block Instance</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BLOCK_INSTANCE_FEATURE_COUNT = 1;

	/**
	 * The number of operations of the '<em>Block Instance</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BLOCK_INSTANCE_OPERATION_COUNT = 0;

	/**
	 * The meta object id for the '{@link com.irtsaintexupery.fiacre.instance.fiacreinstance.impl.CompositionInstanceImpl <em>Composition Instance</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.irtsaintexupery.fiacre.instance.fiacreinstance.impl.CompositionInstanceImpl
	 * @see com.irtsaintexupery.fiacre.instance.fiacreinstance.impl.FiacreinstancePackageImpl#getCompositionInstance()
	 * @generated
	 */
	int COMPOSITION_INSTANCE = 7;

	/**
	 * The feature id for the '<em><b>Block Instances</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPOSITION_INSTANCE__BLOCK_INSTANCES = BLOCK_INSTANCE__BLOCK_INSTANCES;

	/**
	 * The feature id for the '<em><b>Composition</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPOSITION_INSTANCE__COMPOSITION = BLOCK_INSTANCE_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Composition Instance</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPOSITION_INSTANCE_FEATURE_COUNT = BLOCK_INSTANCE_FEATURE_COUNT + 1;

	/**
	 * The number of operations of the '<em>Composition Instance</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPOSITION_INSTANCE_OPERATION_COUNT = BLOCK_INSTANCE_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.irtsaintexupery.fiacre.instance.fiacreinstance.impl.DeclarationInstanceImpl <em>Declaration Instance</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.irtsaintexupery.fiacre.instance.fiacreinstance.impl.DeclarationInstanceImpl
	 * @see com.irtsaintexupery.fiacre.instance.fiacreinstance.impl.FiacreinstancePackageImpl#getDeclarationInstance()
	 * @generated
	 */
	int DECLARATION_INSTANCE = 8;

	/**
	 * The feature id for the '<em><b>Block Instances</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DECLARATION_INSTANCE__BLOCK_INSTANCES = BLOCK_INSTANCE__BLOCK_INSTANCES;

	/**
	 * The feature id for the '<em><b>Variable Declaration Instances</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DECLARATION_INSTANCE__VARIABLE_DECLARATION_INSTANCES = BLOCK_INSTANCE_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DECLARATION_INSTANCE__NAME = BLOCK_INSTANCE_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Instance</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DECLARATION_INSTANCE__INSTANCE = BLOCK_INSTANCE_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Flatname</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DECLARATION_INSTANCE__FLATNAME = BLOCK_INSTANCE_FEATURE_COUNT + 3;

	/**
	 * The number of structural features of the '<em>Declaration Instance</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DECLARATION_INSTANCE_FEATURE_COUNT = BLOCK_INSTANCE_FEATURE_COUNT + 4;

	/**
	 * The number of operations of the '<em>Declaration Instance</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DECLARATION_INSTANCE_OPERATION_COUNT = BLOCK_INSTANCE_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.irtsaintexupery.fiacre.instance.fiacreinstance.impl.ComponentDeclarationInstanceImpl <em>Component Declaration Instance</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.irtsaintexupery.fiacre.instance.fiacreinstance.impl.ComponentDeclarationInstanceImpl
	 * @see com.irtsaintexupery.fiacre.instance.fiacreinstance.impl.FiacreinstancePackageImpl#getComponentDeclarationInstance()
	 * @generated
	 */
	int COMPONENT_DECLARATION_INSTANCE = 9;

	/**
	 * The feature id for the '<em><b>Block Instances</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPONENT_DECLARATION_INSTANCE__BLOCK_INSTANCES = DECLARATION_INSTANCE__BLOCK_INSTANCES;

	/**
	 * The feature id for the '<em><b>Variable Declaration Instances</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPONENT_DECLARATION_INSTANCE__VARIABLE_DECLARATION_INSTANCES = DECLARATION_INSTANCE__VARIABLE_DECLARATION_INSTANCES;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPONENT_DECLARATION_INSTANCE__NAME = DECLARATION_INSTANCE__NAME;

	/**
	 * The feature id for the '<em><b>Instance</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPONENT_DECLARATION_INSTANCE__INSTANCE = DECLARATION_INSTANCE__INSTANCE;

	/**
	 * The feature id for the '<em><b>Flatname</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPONENT_DECLARATION_INSTANCE__FLATNAME = DECLARATION_INSTANCE__FLATNAME;

	/**
	 * The feature id for the '<em><b>Component</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPONENT_DECLARATION_INSTANCE__COMPONENT = DECLARATION_INSTANCE_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Component Declaration Instance</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPONENT_DECLARATION_INSTANCE_FEATURE_COUNT = DECLARATION_INSTANCE_FEATURE_COUNT + 1;

	/**
	 * The number of operations of the '<em>Component Declaration Instance</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPONENT_DECLARATION_INSTANCE_OPERATION_COUNT = DECLARATION_INSTANCE_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.irtsaintexupery.fiacre.instance.fiacreinstance.impl.ProcessDeclarationInstanceImpl <em>Process Declaration Instance</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.irtsaintexupery.fiacre.instance.fiacreinstance.impl.ProcessDeclarationInstanceImpl
	 * @see com.irtsaintexupery.fiacre.instance.fiacreinstance.impl.FiacreinstancePackageImpl#getProcessDeclarationInstance()
	 * @generated
	 */
	int PROCESS_DECLARATION_INSTANCE = 10;

	/**
	 * The feature id for the '<em><b>Block Instances</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_DECLARATION_INSTANCE__BLOCK_INSTANCES = DECLARATION_INSTANCE__BLOCK_INSTANCES;

	/**
	 * The feature id for the '<em><b>Variable Declaration Instances</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_DECLARATION_INSTANCE__VARIABLE_DECLARATION_INSTANCES = DECLARATION_INSTANCE__VARIABLE_DECLARATION_INSTANCES;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_DECLARATION_INSTANCE__NAME = DECLARATION_INSTANCE__NAME;

	/**
	 * The feature id for the '<em><b>Instance</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_DECLARATION_INSTANCE__INSTANCE = DECLARATION_INSTANCE__INSTANCE;

	/**
	 * The feature id for the '<em><b>Flatname</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_DECLARATION_INSTANCE__FLATNAME = DECLARATION_INSTANCE__FLATNAME;

	/**
	 * The feature id for the '<em><b>Current State</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_DECLARATION_INSTANCE__CURRENT_STATE = DECLARATION_INSTANCE_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Process</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_DECLARATION_INSTANCE__PROCESS = DECLARATION_INSTANCE_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Instance Statement Blocks</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_DECLARATION_INSTANCE__INSTANCE_STATEMENT_BLOCKS = DECLARATION_INSTANCE_FEATURE_COUNT + 2;

	/**
	 * The number of structural features of the '<em>Process Declaration Instance</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_DECLARATION_INSTANCE_FEATURE_COUNT = DECLARATION_INSTANCE_FEATURE_COUNT + 3;

	/**
	 * The number of operations of the '<em>Process Declaration Instance</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_DECLARATION_INSTANCE_OPERATION_COUNT = DECLARATION_INSTANCE_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.irtsaintexupery.fiacre.instance.fiacreinstance.impl.InstanceStatementBlockImpl <em>Instance Statement Block</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.irtsaintexupery.fiacre.instance.fiacreinstance.impl.InstanceStatementBlockImpl
	 * @see com.irtsaintexupery.fiacre.instance.fiacreinstance.impl.FiacreinstancePackageImpl#getInstanceStatementBlock()
	 * @generated
	 */
	int INSTANCE_STATEMENT_BLOCK = 11;

	/**
	 * The feature id for the '<em><b>Transition Source</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INSTANCE_STATEMENT_BLOCK__TRANSITION_SOURCE = 0;

	/**
	 * The feature id for the '<em><b>Statements</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INSTANCE_STATEMENT_BLOCK__STATEMENTS = 1;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INSTANCE_STATEMENT_BLOCK__NAME = 2;

	/**
	 * The number of structural features of the '<em>Instance Statement Block</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INSTANCE_STATEMENT_BLOCK_FEATURE_COUNT = 3;

	/**
	 * The number of operations of the '<em>Instance Statement Block</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INSTANCE_STATEMENT_BLOCK_OPERATION_COUNT = 0;

	/**
	 * The meta object id for the '{@link com.irtsaintexupery.fiacre.instance.fiacreinstance.impl.InstanceExecutedStatementBlockImpl <em>Instance Executed Statement Block</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.irtsaintexupery.fiacre.instance.fiacreinstance.impl.InstanceExecutedStatementBlockImpl
	 * @see com.irtsaintexupery.fiacre.instance.fiacreinstance.impl.FiacreinstancePackageImpl#getInstanceExecutedStatementBlock()
	 * @generated
	 */
	int INSTANCE_EXECUTED_STATEMENT_BLOCK = 12;

	/**
	 * The feature id for the '<em><b>Transition Source</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INSTANCE_EXECUTED_STATEMENT_BLOCK__TRANSITION_SOURCE = INSTANCE_STATEMENT_BLOCK__TRANSITION_SOURCE;

	/**
	 * The feature id for the '<em><b>Statements</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INSTANCE_EXECUTED_STATEMENT_BLOCK__STATEMENTS = INSTANCE_STATEMENT_BLOCK__STATEMENTS;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INSTANCE_EXECUTED_STATEMENT_BLOCK__NAME = INSTANCE_STATEMENT_BLOCK__NAME;

	/**
	 * The number of structural features of the '<em>Instance Executed Statement Block</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INSTANCE_EXECUTED_STATEMENT_BLOCK_FEATURE_COUNT = INSTANCE_STATEMENT_BLOCK_FEATURE_COUNT + 0;

	/**
	 * The number of operations of the '<em>Instance Executed Statement Block</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INSTANCE_EXECUTED_STATEMENT_BLOCK_OPERATION_COUNT = INSTANCE_STATEMENT_BLOCK_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.irtsaintexupery.fiacre.instance.fiacreinstance.impl.InstanceExecutableStatementBlockImpl <em>Instance Executable Statement Block</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.irtsaintexupery.fiacre.instance.fiacreinstance.impl.InstanceExecutableStatementBlockImpl
	 * @see com.irtsaintexupery.fiacre.instance.fiacreinstance.impl.FiacreinstancePackageImpl#getInstanceExecutableStatementBlock()
	 * @generated
	 */
	int INSTANCE_EXECUTABLE_STATEMENT_BLOCK = 13;

	/**
	 * The feature id for the '<em><b>Transition Source</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INSTANCE_EXECUTABLE_STATEMENT_BLOCK__TRANSITION_SOURCE = INSTANCE_STATEMENT_BLOCK__TRANSITION_SOURCE;

	/**
	 * The feature id for the '<em><b>Statements</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INSTANCE_EXECUTABLE_STATEMENT_BLOCK__STATEMENTS = INSTANCE_STATEMENT_BLOCK__STATEMENTS;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INSTANCE_EXECUTABLE_STATEMENT_BLOCK__NAME = INSTANCE_STATEMENT_BLOCK__NAME;

	/**
	 * The number of structural features of the '<em>Instance Executable Statement Block</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INSTANCE_EXECUTABLE_STATEMENT_BLOCK_FEATURE_COUNT = INSTANCE_STATEMENT_BLOCK_FEATURE_COUNT + 0;

	/**
	 * The number of operations of the '<em>Instance Executable Statement Block</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INSTANCE_EXECUTABLE_STATEMENT_BLOCK_OPERATION_COUNT = INSTANCE_STATEMENT_BLOCK_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.irtsaintexupery.fiacre.instance.fiacreinstance.impl.InstanceFireableStatementBlockImpl <em>Instance Fireable Statement Block</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.irtsaintexupery.fiacre.instance.fiacreinstance.impl.InstanceFireableStatementBlockImpl
	 * @see com.irtsaintexupery.fiacre.instance.fiacreinstance.impl.FiacreinstancePackageImpl#getInstanceFireableStatementBlock()
	 * @generated
	 */
	int INSTANCE_FIREABLE_STATEMENT_BLOCK = 14;

	/**
	 * The feature id for the '<em><b>Transition Source</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INSTANCE_FIREABLE_STATEMENT_BLOCK__TRANSITION_SOURCE = INSTANCE_EXECUTABLE_STATEMENT_BLOCK__TRANSITION_SOURCE;

	/**
	 * The feature id for the '<em><b>Statements</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INSTANCE_FIREABLE_STATEMENT_BLOCK__STATEMENTS = INSTANCE_EXECUTABLE_STATEMENT_BLOCK__STATEMENTS;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INSTANCE_FIREABLE_STATEMENT_BLOCK__NAME = INSTANCE_EXECUTABLE_STATEMENT_BLOCK__NAME;

	/**
	 * The number of structural features of the '<em>Instance Fireable Statement Block</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INSTANCE_FIREABLE_STATEMENT_BLOCK_FEATURE_COUNT = INSTANCE_EXECUTABLE_STATEMENT_BLOCK_FEATURE_COUNT + 0;

	/**
	 * The number of operations of the '<em>Instance Fireable Statement Block</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INSTANCE_FIREABLE_STATEMENT_BLOCK_OPERATION_COUNT = INSTANCE_EXECUTABLE_STATEMENT_BLOCK_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.irtsaintexupery.fiacre.instance.fiacreinstance.impl.InstanceEnabledStatementBlockImpl <em>Instance Enabled Statement Block</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.irtsaintexupery.fiacre.instance.fiacreinstance.impl.InstanceEnabledStatementBlockImpl
	 * @see com.irtsaintexupery.fiacre.instance.fiacreinstance.impl.FiacreinstancePackageImpl#getInstanceEnabledStatementBlock()
	 * @generated
	 */
	int INSTANCE_ENABLED_STATEMENT_BLOCK = 15;

	/**
	 * The feature id for the '<em><b>Transition Source</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INSTANCE_ENABLED_STATEMENT_BLOCK__TRANSITION_SOURCE = INSTANCE_EXECUTABLE_STATEMENT_BLOCK__TRANSITION_SOURCE;

	/**
	 * The feature id for the '<em><b>Statements</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INSTANCE_ENABLED_STATEMENT_BLOCK__STATEMENTS = INSTANCE_EXECUTABLE_STATEMENT_BLOCK__STATEMENTS;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INSTANCE_ENABLED_STATEMENT_BLOCK__NAME = INSTANCE_EXECUTABLE_STATEMENT_BLOCK__NAME;

	/**
	 * The number of structural features of the '<em>Instance Enabled Statement Block</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INSTANCE_ENABLED_STATEMENT_BLOCK_FEATURE_COUNT = INSTANCE_EXECUTABLE_STATEMENT_BLOCK_FEATURE_COUNT + 0;

	/**
	 * The number of operations of the '<em>Instance Enabled Statement Block</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INSTANCE_ENABLED_STATEMENT_BLOCK_OPERATION_COUNT = INSTANCE_EXECUTABLE_STATEMENT_BLOCK_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.irtsaintexupery.fiacre.instance.fiacreinstance.impl.VariableDeclarationInstanceImpl <em>Variable Declaration Instance</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.irtsaintexupery.fiacre.instance.fiacreinstance.impl.VariableDeclarationInstanceImpl
	 * @see com.irtsaintexupery.fiacre.instance.fiacreinstance.impl.FiacreinstancePackageImpl#getVariableDeclarationInstance()
	 * @generated
	 */
	int VARIABLE_DECLARATION_INSTANCE = 16;

	/**
	 * The feature id for the '<em><b>Variable Declaration</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VARIABLE_DECLARATION_INSTANCE__VARIABLE_DECLARATION = 0;

	/**
	 * The feature id for the '<em><b>Current Value</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VARIABLE_DECLARATION_INSTANCE__CURRENT_VALUE = 1;

	/**
	 * The number of structural features of the '<em>Variable Declaration Instance</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VARIABLE_DECLARATION_INSTANCE_FEATURE_COUNT = 2;

	/**
	 * The number of operations of the '<em>Variable Declaration Instance</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VARIABLE_DECLARATION_INSTANCE_OPERATION_COUNT = 0;


	/**
	 * Returns the meta object for class '{@link com.irtsaintexupery.fiacre.instance.fiacreinstance.InstanceModel <em>Instance Model</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Instance Model</em>'.
	 * @see com.irtsaintexupery.fiacre.instance.fiacreinstance.InstanceModel
	 * @generated
	 */
	EClass getInstanceModel();

	/**
	 * Returns the meta object for the attribute '{@link com.irtsaintexupery.fiacre.instance.fiacreinstance.InstanceModel#getName <em>Name</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Name</em>'.
	 * @see com.irtsaintexupery.fiacre.instance.fiacreinstance.InstanceModel#getName()
	 * @see #getInstanceModel()
	 * @generated
	 */
	EAttribute getInstanceModel_Name();

	/**
	 * Returns the meta object for the reference '{@link com.irtsaintexupery.fiacre.instance.fiacreinstance.InstanceModel#getModel <em>Model</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Model</em>'.
	 * @see com.irtsaintexupery.fiacre.instance.fiacreinstance.InstanceModel#getModel()
	 * @see #getInstanceModel()
	 * @generated
	 */
	EReference getInstanceModel_Model();

	/**
	 * Returns the meta object for the containment reference list '{@link com.irtsaintexupery.fiacre.instance.fiacreinstance.InstanceModel#getInstance <em>Instance</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Instance</em>'.
	 * @see com.irtsaintexupery.fiacre.instance.fiacreinstance.InstanceModel#getInstance()
	 * @see #getInstanceModel()
	 * @generated
	 */
	EReference getInstanceModel_Instance();

	/**
	 * Returns the meta object for the containment reference list '{@link com.irtsaintexupery.fiacre.instance.fiacreinstance.InstanceModel#getStatementBlocks <em>Statement Blocks</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Statement Blocks</em>'.
	 * @see com.irtsaintexupery.fiacre.instance.fiacreinstance.InstanceModel#getStatementBlocks()
	 * @see #getInstanceModel()
	 * @generated
	 */
	EReference getInstanceModel_StatementBlocks();

	/**
	 * Returns the meta object for class '{@link com.irtsaintexupery.fiacre.instance.fiacreinstance.StatementBlock <em>Statement Block</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Statement Block</em>'.
	 * @see com.irtsaintexupery.fiacre.instance.fiacreinstance.StatementBlock
	 * @generated
	 */
	EClass getStatementBlock();

	/**
	 * Returns the meta object for the reference list '{@link com.irtsaintexupery.fiacre.instance.fiacreinstance.StatementBlock#getInstanceStatementBlocks <em>Instance Statement Blocks</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Instance Statement Blocks</em>'.
	 * @see com.irtsaintexupery.fiacre.instance.fiacreinstance.StatementBlock#getInstanceStatementBlocks()
	 * @see #getStatementBlock()
	 * @generated
	 */
	EReference getStatementBlock_InstanceStatementBlocks();

	/**
	 * Returns the meta object for the attribute '{@link com.irtsaintexupery.fiacre.instance.fiacreinstance.StatementBlock#getName <em>Name</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Name</em>'.
	 * @see com.irtsaintexupery.fiacre.instance.fiacreinstance.StatementBlock#getName()
	 * @see #getStatementBlock()
	 * @generated
	 */
	EAttribute getStatementBlock_Name();

	/**
	 * Returns the meta object for class '{@link com.irtsaintexupery.fiacre.instance.fiacreinstance.ExecutedStatementBlock <em>Executed Statement Block</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Executed Statement Block</em>'.
	 * @see com.irtsaintexupery.fiacre.instance.fiacreinstance.ExecutedStatementBlock
	 * @generated
	 */
	EClass getExecutedStatementBlock();

	/**
	 * Returns the meta object for class '{@link com.irtsaintexupery.fiacre.instance.fiacreinstance.ExecutableStatementBlock <em>Executable Statement Block</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Executable Statement Block</em>'.
	 * @see com.irtsaintexupery.fiacre.instance.fiacreinstance.ExecutableStatementBlock
	 * @generated
	 */
	EClass getExecutableStatementBlock();

	/**
	 * Returns the meta object for the attribute '{@link com.irtsaintexupery.fiacre.instance.fiacreinstance.ExecutableStatementBlock#getDate <em>Date</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Date</em>'.
	 * @see com.irtsaintexupery.fiacre.instance.fiacreinstance.ExecutableStatementBlock#getDate()
	 * @see #getExecutableStatementBlock()
	 * @generated
	 */
	EAttribute getExecutableStatementBlock_Date();

	/**
	 * Returns the meta object for class '{@link com.irtsaintexupery.fiacre.instance.fiacreinstance.FireableStatementBlock <em>Fireable Statement Block</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Fireable Statement Block</em>'.
	 * @see com.irtsaintexupery.fiacre.instance.fiacreinstance.FireableStatementBlock
	 * @generated
	 */
	EClass getFireableStatementBlock();

	/**
	 * Returns the meta object for class '{@link com.irtsaintexupery.fiacre.instance.fiacreinstance.EnabledStatementBlock <em>Enabled Statement Block</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Enabled Statement Block</em>'.
	 * @see com.irtsaintexupery.fiacre.instance.fiacreinstance.EnabledStatementBlock
	 * @generated
	 */
	EClass getEnabledStatementBlock();

	/**
	 * Returns the meta object for class '{@link com.irtsaintexupery.fiacre.instance.fiacreinstance.BlockInstance <em>Block Instance</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Block Instance</em>'.
	 * @see com.irtsaintexupery.fiacre.instance.fiacreinstance.BlockInstance
	 * @generated
	 */
	EClass getBlockInstance();

	/**
	 * Returns the meta object for the containment reference list '{@link com.irtsaintexupery.fiacre.instance.fiacreinstance.BlockInstance#getBlockInstances <em>Block Instances</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Block Instances</em>'.
	 * @see com.irtsaintexupery.fiacre.instance.fiacreinstance.BlockInstance#getBlockInstances()
	 * @see #getBlockInstance()
	 * @generated
	 */
	EReference getBlockInstance_BlockInstances();

	/**
	 * Returns the meta object for class '{@link com.irtsaintexupery.fiacre.instance.fiacreinstance.CompositionInstance <em>Composition Instance</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Composition Instance</em>'.
	 * @see com.irtsaintexupery.fiacre.instance.fiacreinstance.CompositionInstance
	 * @generated
	 */
	EClass getCompositionInstance();

	/**
	 * Returns the meta object for the reference '{@link com.irtsaintexupery.fiacre.instance.fiacreinstance.CompositionInstance#getComposition <em>Composition</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Composition</em>'.
	 * @see com.irtsaintexupery.fiacre.instance.fiacreinstance.CompositionInstance#getComposition()
	 * @see #getCompositionInstance()
	 * @generated
	 */
	EReference getCompositionInstance_Composition();

	/**
	 * Returns the meta object for class '{@link com.irtsaintexupery.fiacre.instance.fiacreinstance.DeclarationInstance <em>Declaration Instance</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Declaration Instance</em>'.
	 * @see com.irtsaintexupery.fiacre.instance.fiacreinstance.DeclarationInstance
	 * @generated
	 */
	EClass getDeclarationInstance();

	/**
	 * Returns the meta object for the containment reference list '{@link com.irtsaintexupery.fiacre.instance.fiacreinstance.DeclarationInstance#getVariableDeclarationInstances <em>Variable Declaration Instances</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Variable Declaration Instances</em>'.
	 * @see com.irtsaintexupery.fiacre.instance.fiacreinstance.DeclarationInstance#getVariableDeclarationInstances()
	 * @see #getDeclarationInstance()
	 * @generated
	 */
	EReference getDeclarationInstance_VariableDeclarationInstances();

	/**
	 * Returns the meta object for the attribute '{@link com.irtsaintexupery.fiacre.instance.fiacreinstance.DeclarationInstance#getName <em>Name</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Name</em>'.
	 * @see com.irtsaintexupery.fiacre.instance.fiacreinstance.DeclarationInstance#getName()
	 * @see #getDeclarationInstance()
	 * @generated
	 */
	EAttribute getDeclarationInstance_Name();

	/**
	 * Returns the meta object for the reference '{@link com.irtsaintexupery.fiacre.instance.fiacreinstance.DeclarationInstance#getInstance <em>Instance</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Instance</em>'.
	 * @see com.irtsaintexupery.fiacre.instance.fiacreinstance.DeclarationInstance#getInstance()
	 * @see #getDeclarationInstance()
	 * @generated
	 */
	EReference getDeclarationInstance_Instance();

	/**
	 * Returns the meta object for the attribute '{@link com.irtsaintexupery.fiacre.instance.fiacreinstance.DeclarationInstance#getFlatname <em>Flatname</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Flatname</em>'.
	 * @see com.irtsaintexupery.fiacre.instance.fiacreinstance.DeclarationInstance#getFlatname()
	 * @see #getDeclarationInstance()
	 * @generated
	 */
	EAttribute getDeclarationInstance_Flatname();

	/**
	 * Returns the meta object for class '{@link com.irtsaintexupery.fiacre.instance.fiacreinstance.ComponentDeclarationInstance <em>Component Declaration Instance</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Component Declaration Instance</em>'.
	 * @see com.irtsaintexupery.fiacre.instance.fiacreinstance.ComponentDeclarationInstance
	 * @generated
	 */
	EClass getComponentDeclarationInstance();

	/**
	 * Returns the meta object for the reference '{@link com.irtsaintexupery.fiacre.instance.fiacreinstance.ComponentDeclarationInstance#getComponent <em>Component</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Component</em>'.
	 * @see com.irtsaintexupery.fiacre.instance.fiacreinstance.ComponentDeclarationInstance#getComponent()
	 * @see #getComponentDeclarationInstance()
	 * @generated
	 */
	EReference getComponentDeclarationInstance_Component();

	/**
	 * Returns the meta object for class '{@link com.irtsaintexupery.fiacre.instance.fiacreinstance.ProcessDeclarationInstance <em>Process Declaration Instance</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Process Declaration Instance</em>'.
	 * @see com.irtsaintexupery.fiacre.instance.fiacreinstance.ProcessDeclarationInstance
	 * @generated
	 */
	EClass getProcessDeclarationInstance();

	/**
	 * Returns the meta object for the reference '{@link com.irtsaintexupery.fiacre.instance.fiacreinstance.ProcessDeclarationInstance#getCurrentState <em>Current State</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Current State</em>'.
	 * @see com.irtsaintexupery.fiacre.instance.fiacreinstance.ProcessDeclarationInstance#getCurrentState()
	 * @see #getProcessDeclarationInstance()
	 * @generated
	 */
	EReference getProcessDeclarationInstance_CurrentState();

	/**
	 * Returns the meta object for the reference '{@link com.irtsaintexupery.fiacre.instance.fiacreinstance.ProcessDeclarationInstance#getProcess <em>Process</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Process</em>'.
	 * @see com.irtsaintexupery.fiacre.instance.fiacreinstance.ProcessDeclarationInstance#getProcess()
	 * @see #getProcessDeclarationInstance()
	 * @generated
	 */
	EReference getProcessDeclarationInstance_Process();

	/**
	 * Returns the meta object for the containment reference list '{@link com.irtsaintexupery.fiacre.instance.fiacreinstance.ProcessDeclarationInstance#getInstanceStatementBlocks <em>Instance Statement Blocks</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Instance Statement Blocks</em>'.
	 * @see com.irtsaintexupery.fiacre.instance.fiacreinstance.ProcessDeclarationInstance#getInstanceStatementBlocks()
	 * @see #getProcessDeclarationInstance()
	 * @generated
	 */
	EReference getProcessDeclarationInstance_InstanceStatementBlocks();

	/**
	 * Returns the meta object for class '{@link com.irtsaintexupery.fiacre.instance.fiacreinstance.InstanceStatementBlock <em>Instance Statement Block</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Instance Statement Block</em>'.
	 * @see com.irtsaintexupery.fiacre.instance.fiacreinstance.InstanceStatementBlock
	 * @generated
	 */
	EClass getInstanceStatementBlock();

	/**
	 * Returns the meta object for the reference '{@link com.irtsaintexupery.fiacre.instance.fiacreinstance.InstanceStatementBlock#getTransitionSource <em>Transition Source</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Transition Source</em>'.
	 * @see com.irtsaintexupery.fiacre.instance.fiacreinstance.InstanceStatementBlock#getTransitionSource()
	 * @see #getInstanceStatementBlock()
	 * @generated
	 */
	EReference getInstanceStatementBlock_TransitionSource();

	/**
	 * Returns the meta object for the reference list '{@link com.irtsaintexupery.fiacre.instance.fiacreinstance.InstanceStatementBlock#getStatements <em>Statements</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Statements</em>'.
	 * @see com.irtsaintexupery.fiacre.instance.fiacreinstance.InstanceStatementBlock#getStatements()
	 * @see #getInstanceStatementBlock()
	 * @generated
	 */
	EReference getInstanceStatementBlock_Statements();

	/**
	 * Returns the meta object for the attribute '{@link com.irtsaintexupery.fiacre.instance.fiacreinstance.InstanceStatementBlock#getName <em>Name</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Name</em>'.
	 * @see com.irtsaintexupery.fiacre.instance.fiacreinstance.InstanceStatementBlock#getName()
	 * @see #getInstanceStatementBlock()
	 * @generated
	 */
	EAttribute getInstanceStatementBlock_Name();

	/**
	 * Returns the meta object for class '{@link com.irtsaintexupery.fiacre.instance.fiacreinstance.InstanceExecutedStatementBlock <em>Instance Executed Statement Block</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Instance Executed Statement Block</em>'.
	 * @see com.irtsaintexupery.fiacre.instance.fiacreinstance.InstanceExecutedStatementBlock
	 * @generated
	 */
	EClass getInstanceExecutedStatementBlock();

	/**
	 * Returns the meta object for class '{@link com.irtsaintexupery.fiacre.instance.fiacreinstance.InstanceExecutableStatementBlock <em>Instance Executable Statement Block</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Instance Executable Statement Block</em>'.
	 * @see com.irtsaintexupery.fiacre.instance.fiacreinstance.InstanceExecutableStatementBlock
	 * @generated
	 */
	EClass getInstanceExecutableStatementBlock();

	/**
	 * Returns the meta object for class '{@link com.irtsaintexupery.fiacre.instance.fiacreinstance.InstanceFireableStatementBlock <em>Instance Fireable Statement Block</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Instance Fireable Statement Block</em>'.
	 * @see com.irtsaintexupery.fiacre.instance.fiacreinstance.InstanceFireableStatementBlock
	 * @generated
	 */
	EClass getInstanceFireableStatementBlock();

	/**
	 * Returns the meta object for class '{@link com.irtsaintexupery.fiacre.instance.fiacreinstance.InstanceEnabledStatementBlock <em>Instance Enabled Statement Block</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Instance Enabled Statement Block</em>'.
	 * @see com.irtsaintexupery.fiacre.instance.fiacreinstance.InstanceEnabledStatementBlock
	 * @generated
	 */
	EClass getInstanceEnabledStatementBlock();

	/**
	 * Returns the meta object for class '{@link com.irtsaintexupery.fiacre.instance.fiacreinstance.VariableDeclarationInstance <em>Variable Declaration Instance</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Variable Declaration Instance</em>'.
	 * @see com.irtsaintexupery.fiacre.instance.fiacreinstance.VariableDeclarationInstance
	 * @generated
	 */
	EClass getVariableDeclarationInstance();

	/**
	 * Returns the meta object for the reference '{@link com.irtsaintexupery.fiacre.instance.fiacreinstance.VariableDeclarationInstance#getVariableDeclaration <em>Variable Declaration</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Variable Declaration</em>'.
	 * @see com.irtsaintexupery.fiacre.instance.fiacreinstance.VariableDeclarationInstance#getVariableDeclaration()
	 * @see #getVariableDeclarationInstance()
	 * @generated
	 */
	EReference getVariableDeclarationInstance_VariableDeclaration();

	/**
	 * Returns the meta object for the containment reference '{@link com.irtsaintexupery.fiacre.instance.fiacreinstance.VariableDeclarationInstance#getCurrentValue <em>Current Value</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Current Value</em>'.
	 * @see com.irtsaintexupery.fiacre.instance.fiacreinstance.VariableDeclarationInstance#getCurrentValue()
	 * @see #getVariableDeclarationInstance()
	 * @generated
	 */
	EReference getVariableDeclarationInstance_CurrentValue();

	/**
	 * Returns the factory that creates the instances of the model.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the factory that creates the instances of the model.
	 * @generated
	 */
	FiacreinstanceFactory getFiacreinstanceFactory();

	/**
	 * <!-- begin-user-doc -->
	 * Defines literals for the meta objects that represent
	 * <ul>
	 *   <li>each class,</li>
	 *   <li>each feature of each class,</li>
	 *   <li>each operation of each class,</li>
	 *   <li>each enum,</li>
	 *   <li>and each data type</li>
	 * </ul>
	 * <!-- end-user-doc -->
	 * @generated
	 */
	interface Literals {
		/**
		 * The meta object literal for the '{@link com.irtsaintexupery.fiacre.instance.fiacreinstance.impl.InstanceModelImpl <em>Instance Model</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.irtsaintexupery.fiacre.instance.fiacreinstance.impl.InstanceModelImpl
		 * @see com.irtsaintexupery.fiacre.instance.fiacreinstance.impl.FiacreinstancePackageImpl#getInstanceModel()
		 * @generated
		 */
		EClass INSTANCE_MODEL = eINSTANCE.getInstanceModel();

		/**
		 * The meta object literal for the '<em><b>Name</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute INSTANCE_MODEL__NAME = eINSTANCE.getInstanceModel_Name();

		/**
		 * The meta object literal for the '<em><b>Model</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference INSTANCE_MODEL__MODEL = eINSTANCE.getInstanceModel_Model();

		/**
		 * The meta object literal for the '<em><b>Instance</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference INSTANCE_MODEL__INSTANCE = eINSTANCE.getInstanceModel_Instance();

		/**
		 * The meta object literal for the '<em><b>Statement Blocks</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference INSTANCE_MODEL__STATEMENT_BLOCKS = eINSTANCE.getInstanceModel_StatementBlocks();

		/**
		 * The meta object literal for the '{@link com.irtsaintexupery.fiacre.instance.fiacreinstance.impl.StatementBlockImpl <em>Statement Block</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.irtsaintexupery.fiacre.instance.fiacreinstance.impl.StatementBlockImpl
		 * @see com.irtsaintexupery.fiacre.instance.fiacreinstance.impl.FiacreinstancePackageImpl#getStatementBlock()
		 * @generated
		 */
		EClass STATEMENT_BLOCK = eINSTANCE.getStatementBlock();

		/**
		 * The meta object literal for the '<em><b>Instance Statement Blocks</b></em>' reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference STATEMENT_BLOCK__INSTANCE_STATEMENT_BLOCKS = eINSTANCE.getStatementBlock_InstanceStatementBlocks();

		/**
		 * The meta object literal for the '<em><b>Name</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute STATEMENT_BLOCK__NAME = eINSTANCE.getStatementBlock_Name();

		/**
		 * The meta object literal for the '{@link com.irtsaintexupery.fiacre.instance.fiacreinstance.impl.ExecutedStatementBlockImpl <em>Executed Statement Block</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.irtsaintexupery.fiacre.instance.fiacreinstance.impl.ExecutedStatementBlockImpl
		 * @see com.irtsaintexupery.fiacre.instance.fiacreinstance.impl.FiacreinstancePackageImpl#getExecutedStatementBlock()
		 * @generated
		 */
		EClass EXECUTED_STATEMENT_BLOCK = eINSTANCE.getExecutedStatementBlock();

		/**
		 * The meta object literal for the '{@link com.irtsaintexupery.fiacre.instance.fiacreinstance.impl.ExecutableStatementBlockImpl <em>Executable Statement Block</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.irtsaintexupery.fiacre.instance.fiacreinstance.impl.ExecutableStatementBlockImpl
		 * @see com.irtsaintexupery.fiacre.instance.fiacreinstance.impl.FiacreinstancePackageImpl#getExecutableStatementBlock()
		 * @generated
		 */
		EClass EXECUTABLE_STATEMENT_BLOCK = eINSTANCE.getExecutableStatementBlock();

		/**
		 * The meta object literal for the '<em><b>Date</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute EXECUTABLE_STATEMENT_BLOCK__DATE = eINSTANCE.getExecutableStatementBlock_Date();

		/**
		 * The meta object literal for the '{@link com.irtsaintexupery.fiacre.instance.fiacreinstance.impl.FireableStatementBlockImpl <em>Fireable Statement Block</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.irtsaintexupery.fiacre.instance.fiacreinstance.impl.FireableStatementBlockImpl
		 * @see com.irtsaintexupery.fiacre.instance.fiacreinstance.impl.FiacreinstancePackageImpl#getFireableStatementBlock()
		 * @generated
		 */
		EClass FIREABLE_STATEMENT_BLOCK = eINSTANCE.getFireableStatementBlock();

		/**
		 * The meta object literal for the '{@link com.irtsaintexupery.fiacre.instance.fiacreinstance.impl.EnabledStatementBlockImpl <em>Enabled Statement Block</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.irtsaintexupery.fiacre.instance.fiacreinstance.impl.EnabledStatementBlockImpl
		 * @see com.irtsaintexupery.fiacre.instance.fiacreinstance.impl.FiacreinstancePackageImpl#getEnabledStatementBlock()
		 * @generated
		 */
		EClass ENABLED_STATEMENT_BLOCK = eINSTANCE.getEnabledStatementBlock();

		/**
		 * The meta object literal for the '{@link com.irtsaintexupery.fiacre.instance.fiacreinstance.impl.BlockInstanceImpl <em>Block Instance</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.irtsaintexupery.fiacre.instance.fiacreinstance.impl.BlockInstanceImpl
		 * @see com.irtsaintexupery.fiacre.instance.fiacreinstance.impl.FiacreinstancePackageImpl#getBlockInstance()
		 * @generated
		 */
		EClass BLOCK_INSTANCE = eINSTANCE.getBlockInstance();

		/**
		 * The meta object literal for the '<em><b>Block Instances</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference BLOCK_INSTANCE__BLOCK_INSTANCES = eINSTANCE.getBlockInstance_BlockInstances();

		/**
		 * The meta object literal for the '{@link com.irtsaintexupery.fiacre.instance.fiacreinstance.impl.CompositionInstanceImpl <em>Composition Instance</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.irtsaintexupery.fiacre.instance.fiacreinstance.impl.CompositionInstanceImpl
		 * @see com.irtsaintexupery.fiacre.instance.fiacreinstance.impl.FiacreinstancePackageImpl#getCompositionInstance()
		 * @generated
		 */
		EClass COMPOSITION_INSTANCE = eINSTANCE.getCompositionInstance();

		/**
		 * The meta object literal for the '<em><b>Composition</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference COMPOSITION_INSTANCE__COMPOSITION = eINSTANCE.getCompositionInstance_Composition();

		/**
		 * The meta object literal for the '{@link com.irtsaintexupery.fiacre.instance.fiacreinstance.impl.DeclarationInstanceImpl <em>Declaration Instance</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.irtsaintexupery.fiacre.instance.fiacreinstance.impl.DeclarationInstanceImpl
		 * @see com.irtsaintexupery.fiacre.instance.fiacreinstance.impl.FiacreinstancePackageImpl#getDeclarationInstance()
		 * @generated
		 */
		EClass DECLARATION_INSTANCE = eINSTANCE.getDeclarationInstance();

		/**
		 * The meta object literal for the '<em><b>Variable Declaration Instances</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference DECLARATION_INSTANCE__VARIABLE_DECLARATION_INSTANCES = eINSTANCE.getDeclarationInstance_VariableDeclarationInstances();

		/**
		 * The meta object literal for the '<em><b>Name</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute DECLARATION_INSTANCE__NAME = eINSTANCE.getDeclarationInstance_Name();

		/**
		 * The meta object literal for the '<em><b>Instance</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference DECLARATION_INSTANCE__INSTANCE = eINSTANCE.getDeclarationInstance_Instance();

		/**
		 * The meta object literal for the '<em><b>Flatname</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute DECLARATION_INSTANCE__FLATNAME = eINSTANCE.getDeclarationInstance_Flatname();

		/**
		 * The meta object literal for the '{@link com.irtsaintexupery.fiacre.instance.fiacreinstance.impl.ComponentDeclarationInstanceImpl <em>Component Declaration Instance</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.irtsaintexupery.fiacre.instance.fiacreinstance.impl.ComponentDeclarationInstanceImpl
		 * @see com.irtsaintexupery.fiacre.instance.fiacreinstance.impl.FiacreinstancePackageImpl#getComponentDeclarationInstance()
		 * @generated
		 */
		EClass COMPONENT_DECLARATION_INSTANCE = eINSTANCE.getComponentDeclarationInstance();

		/**
		 * The meta object literal for the '<em><b>Component</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference COMPONENT_DECLARATION_INSTANCE__COMPONENT = eINSTANCE.getComponentDeclarationInstance_Component();

		/**
		 * The meta object literal for the '{@link com.irtsaintexupery.fiacre.instance.fiacreinstance.impl.ProcessDeclarationInstanceImpl <em>Process Declaration Instance</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.irtsaintexupery.fiacre.instance.fiacreinstance.impl.ProcessDeclarationInstanceImpl
		 * @see com.irtsaintexupery.fiacre.instance.fiacreinstance.impl.FiacreinstancePackageImpl#getProcessDeclarationInstance()
		 * @generated
		 */
		EClass PROCESS_DECLARATION_INSTANCE = eINSTANCE.getProcessDeclarationInstance();

		/**
		 * The meta object literal for the '<em><b>Current State</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference PROCESS_DECLARATION_INSTANCE__CURRENT_STATE = eINSTANCE.getProcessDeclarationInstance_CurrentState();

		/**
		 * The meta object literal for the '<em><b>Process</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference PROCESS_DECLARATION_INSTANCE__PROCESS = eINSTANCE.getProcessDeclarationInstance_Process();

		/**
		 * The meta object literal for the '<em><b>Instance Statement Blocks</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference PROCESS_DECLARATION_INSTANCE__INSTANCE_STATEMENT_BLOCKS = eINSTANCE.getProcessDeclarationInstance_InstanceStatementBlocks();

		/**
		 * The meta object literal for the '{@link com.irtsaintexupery.fiacre.instance.fiacreinstance.impl.InstanceStatementBlockImpl <em>Instance Statement Block</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.irtsaintexupery.fiacre.instance.fiacreinstance.impl.InstanceStatementBlockImpl
		 * @see com.irtsaintexupery.fiacre.instance.fiacreinstance.impl.FiacreinstancePackageImpl#getInstanceStatementBlock()
		 * @generated
		 */
		EClass INSTANCE_STATEMENT_BLOCK = eINSTANCE.getInstanceStatementBlock();

		/**
		 * The meta object literal for the '<em><b>Transition Source</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference INSTANCE_STATEMENT_BLOCK__TRANSITION_SOURCE = eINSTANCE.getInstanceStatementBlock_TransitionSource();

		/**
		 * The meta object literal for the '<em><b>Statements</b></em>' reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference INSTANCE_STATEMENT_BLOCK__STATEMENTS = eINSTANCE.getInstanceStatementBlock_Statements();

		/**
		 * The meta object literal for the '<em><b>Name</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute INSTANCE_STATEMENT_BLOCK__NAME = eINSTANCE.getInstanceStatementBlock_Name();

		/**
		 * The meta object literal for the '{@link com.irtsaintexupery.fiacre.instance.fiacreinstance.impl.InstanceExecutedStatementBlockImpl <em>Instance Executed Statement Block</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.irtsaintexupery.fiacre.instance.fiacreinstance.impl.InstanceExecutedStatementBlockImpl
		 * @see com.irtsaintexupery.fiacre.instance.fiacreinstance.impl.FiacreinstancePackageImpl#getInstanceExecutedStatementBlock()
		 * @generated
		 */
		EClass INSTANCE_EXECUTED_STATEMENT_BLOCK = eINSTANCE.getInstanceExecutedStatementBlock();

		/**
		 * The meta object literal for the '{@link com.irtsaintexupery.fiacre.instance.fiacreinstance.impl.InstanceExecutableStatementBlockImpl <em>Instance Executable Statement Block</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.irtsaintexupery.fiacre.instance.fiacreinstance.impl.InstanceExecutableStatementBlockImpl
		 * @see com.irtsaintexupery.fiacre.instance.fiacreinstance.impl.FiacreinstancePackageImpl#getInstanceExecutableStatementBlock()
		 * @generated
		 */
		EClass INSTANCE_EXECUTABLE_STATEMENT_BLOCK = eINSTANCE.getInstanceExecutableStatementBlock();

		/**
		 * The meta object literal for the '{@link com.irtsaintexupery.fiacre.instance.fiacreinstance.impl.InstanceFireableStatementBlockImpl <em>Instance Fireable Statement Block</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.irtsaintexupery.fiacre.instance.fiacreinstance.impl.InstanceFireableStatementBlockImpl
		 * @see com.irtsaintexupery.fiacre.instance.fiacreinstance.impl.FiacreinstancePackageImpl#getInstanceFireableStatementBlock()
		 * @generated
		 */
		EClass INSTANCE_FIREABLE_STATEMENT_BLOCK = eINSTANCE.getInstanceFireableStatementBlock();

		/**
		 * The meta object literal for the '{@link com.irtsaintexupery.fiacre.instance.fiacreinstance.impl.InstanceEnabledStatementBlockImpl <em>Instance Enabled Statement Block</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.irtsaintexupery.fiacre.instance.fiacreinstance.impl.InstanceEnabledStatementBlockImpl
		 * @see com.irtsaintexupery.fiacre.instance.fiacreinstance.impl.FiacreinstancePackageImpl#getInstanceEnabledStatementBlock()
		 * @generated
		 */
		EClass INSTANCE_ENABLED_STATEMENT_BLOCK = eINSTANCE.getInstanceEnabledStatementBlock();

		/**
		 * The meta object literal for the '{@link com.irtsaintexupery.fiacre.instance.fiacreinstance.impl.VariableDeclarationInstanceImpl <em>Variable Declaration Instance</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.irtsaintexupery.fiacre.instance.fiacreinstance.impl.VariableDeclarationInstanceImpl
		 * @see com.irtsaintexupery.fiacre.instance.fiacreinstance.impl.FiacreinstancePackageImpl#getVariableDeclarationInstance()
		 * @generated
		 */
		EClass VARIABLE_DECLARATION_INSTANCE = eINSTANCE.getVariableDeclarationInstance();

		/**
		 * The meta object literal for the '<em><b>Variable Declaration</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference VARIABLE_DECLARATION_INSTANCE__VARIABLE_DECLARATION = eINSTANCE.getVariableDeclarationInstance_VariableDeclaration();

		/**
		 * The meta object literal for the '<em><b>Current Value</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference VARIABLE_DECLARATION_INSTANCE__CURRENT_VALUE = eINSTANCE.getVariableDeclarationInstance_CurrentValue();

	}

} //FiacreinstancePackage
