/*******************************************************************************
 * Copyright (c) 2015, 2016 CNRS, IRIT, IRT AESE (IRT Saint Exupéry).
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the LGPL 3.0
 * which accompanies this distribution, and is available at
 * https://www.gnu.org/licenses/lgpl-3.0-standalone.html
 *
 * Contributors:
 *     Faiez Zalila - initial API and implementation and/or initial documentation
 *******************************************************************************/
/**
 */
package com.irtsaintexupery.fiacre.instance.fiacreinstance;

import fr.irit.fiacre.xtext.fiacre.ProcessDeclaration;
import fr.irit.fiacre.xtext.fiacre.StateDeclaration;

import org.eclipse.emf.common.util.EList;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Process Declaration Instance</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link com.irtsaintexupery.fiacre.instance.fiacreinstance.ProcessDeclarationInstance#getCurrentState <em>Current State</em>}</li>
 *   <li>{@link com.irtsaintexupery.fiacre.instance.fiacreinstance.ProcessDeclarationInstance#getProcess <em>Process</em>}</li>
 *   <li>{@link com.irtsaintexupery.fiacre.instance.fiacreinstance.ProcessDeclarationInstance#getInstanceStatementBlocks <em>Instance Statement Blocks</em>}</li>
 * </ul>
 *
 * @see com.irtsaintexupery.fiacre.instance.fiacreinstance.FiacreinstancePackage#getProcessDeclarationInstance()
 * @model
 * @generated
 */
public interface ProcessDeclarationInstance extends DeclarationInstance {
	/**
	 * Returns the value of the '<em><b>Current State</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Current State</em>' reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Current State</em>' reference.
	 * @see #setCurrentState(StateDeclaration)
	 * @see com.irtsaintexupery.fiacre.instance.fiacreinstance.FiacreinstancePackage#getProcessDeclarationInstance_CurrentState()
	 * @model
	 * @generated
	 */
	StateDeclaration getCurrentState();

	/**
	 * Sets the value of the '{@link com.irtsaintexupery.fiacre.instance.fiacreinstance.ProcessDeclarationInstance#getCurrentState <em>Current State</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Current State</em>' reference.
	 * @see #getCurrentState()
	 * @generated
	 */
	void setCurrentState(StateDeclaration value);

	/**
	 * Returns the value of the '<em><b>Process</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Process</em>' reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Process</em>' reference.
	 * @see #setProcess(ProcessDeclaration)
	 * @see com.irtsaintexupery.fiacre.instance.fiacreinstance.FiacreinstancePackage#getProcessDeclarationInstance_Process()
	 * @model required="true"
	 * @generated
	 */
	ProcessDeclaration getProcess();

	/**
	 * Sets the value of the '{@link com.irtsaintexupery.fiacre.instance.fiacreinstance.ProcessDeclarationInstance#getProcess <em>Process</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Process</em>' reference.
	 * @see #getProcess()
	 * @generated
	 */
	void setProcess(ProcessDeclaration value);

	/**
	 * Returns the value of the '<em><b>Instance Statement Blocks</b></em>' containment reference list.
	 * The list contents are of type {@link com.irtsaintexupery.fiacre.instance.fiacreinstance.InstanceStatementBlock}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Instance Statement Blocks</em>' containment reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Instance Statement Blocks</em>' containment reference list.
	 * @see com.irtsaintexupery.fiacre.instance.fiacreinstance.FiacreinstancePackage#getProcessDeclarationInstance_InstanceStatementBlocks()
	 * @model containment="true"
	 * @generated
	 */
	EList<InstanceStatementBlock> getInstanceStatementBlocks();

} // ProcessDeclarationInstance
