/*******************************************************************************
 * Copyright (c) 2015, 2016 CNRS, IRIT, IRT AESE (IRT Saint Exupéry).
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the LGPL 3.0
 * which accompanies this distribution, and is available at
 * https://www.gnu.org/licenses/lgpl-3.0-standalone.html
 *
 * Contributors:
 *     Faiez Zalila - initial API and implementation and/or initial documentation
 *******************************************************************************/
/**
 */
package com.irtsaintexupery.fiacre.instance.fiacreinstance.util;

import org.eclipse.emf.common.notify.Adapter;
import org.eclipse.emf.common.notify.Notifier;

import org.eclipse.emf.common.notify.impl.AdapterFactoryImpl;

import org.eclipse.emf.ecore.EObject;

import com.irtsaintexupery.fiacre.instance.fiacreinstance.*;

/**
 * <!-- begin-user-doc -->
 * The <b>Adapter Factory</b> for the model.
 * It provides an adapter <code>createXXX</code> method for each class of the model.
 * <!-- end-user-doc -->
 * @see com.irtsaintexupery.fiacre.instance.fiacreinstance.FiacreinstancePackage
 * @generated
 */
public class FiacreinstanceAdapterFactory extends AdapterFactoryImpl {
	/**
	 * The cached model package.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected static FiacreinstancePackage modelPackage;

	/**
	 * Creates an instance of the adapter factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public FiacreinstanceAdapterFactory() {
		if (modelPackage == null) {
			modelPackage = FiacreinstancePackage.eINSTANCE;
		}
	}

	/**
	 * Returns whether this factory is applicable for the type of the object.
	 * <!-- begin-user-doc -->
	 * This implementation returns <code>true</code> if the object is either the model's package or is an instance object of the model.
	 * <!-- end-user-doc -->
	 * @return whether this factory is applicable for the type of the object.
	 * @generated
	 */
	@Override
	public boolean isFactoryForType(Object object) {
		if (object == modelPackage) {
			return true;
		}
		if (object instanceof EObject) {
			return ((EObject)object).eClass().getEPackage() == modelPackage;
		}
		return false;
	}

	/**
	 * The switch that delegates to the <code>createXXX</code> methods.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected FiacreinstanceSwitch<Adapter> modelSwitch =
		new FiacreinstanceSwitch<Adapter>() {
			@Override
			public Adapter caseInstanceModel(InstanceModel object) {
				return createInstanceModelAdapter();
			}
			@Override
			public Adapter caseStatementBlock(StatementBlock object) {
				return createStatementBlockAdapter();
			}
			@Override
			public Adapter caseExecutedStatementBlock(ExecutedStatementBlock object) {
				return createExecutedStatementBlockAdapter();
			}
			@Override
			public Adapter caseExecutableStatementBlock(ExecutableStatementBlock object) {
				return createExecutableStatementBlockAdapter();
			}
			@Override
			public Adapter caseFireableStatementBlock(FireableStatementBlock object) {
				return createFireableStatementBlockAdapter();
			}
			@Override
			public Adapter caseEnabledStatementBlock(EnabledStatementBlock object) {
				return createEnabledStatementBlockAdapter();
			}
			@Override
			public Adapter caseBlockInstance(BlockInstance object) {
				return createBlockInstanceAdapter();
			}
			@Override
			public Adapter caseCompositionInstance(CompositionInstance object) {
				return createCompositionInstanceAdapter();
			}
			@Override
			public Adapter caseDeclarationInstance(DeclarationInstance object) {
				return createDeclarationInstanceAdapter();
			}
			@Override
			public Adapter caseComponentDeclarationInstance(ComponentDeclarationInstance object) {
				return createComponentDeclarationInstanceAdapter();
			}
			@Override
			public Adapter caseProcessDeclarationInstance(ProcessDeclarationInstance object) {
				return createProcessDeclarationInstanceAdapter();
			}
			@Override
			public Adapter caseInstanceStatementBlock(InstanceStatementBlock object) {
				return createInstanceStatementBlockAdapter();
			}
			@Override
			public Adapter caseInstanceExecutedStatementBlock(InstanceExecutedStatementBlock object) {
				return createInstanceExecutedStatementBlockAdapter();
			}
			@Override
			public Adapter caseInstanceExecutableStatementBlock(InstanceExecutableStatementBlock object) {
				return createInstanceExecutableStatementBlockAdapter();
			}
			@Override
			public Adapter caseInstanceFireableStatementBlock(InstanceFireableStatementBlock object) {
				return createInstanceFireableStatementBlockAdapter();
			}
			@Override
			public Adapter caseInstanceEnabledStatementBlock(InstanceEnabledStatementBlock object) {
				return createInstanceEnabledStatementBlockAdapter();
			}
			@Override
			public Adapter caseVariableDeclarationInstance(VariableDeclarationInstance object) {
				return createVariableDeclarationInstanceAdapter();
			}
			@Override
			public Adapter defaultCase(EObject object) {
				return createEObjectAdapter();
			}
		};

	/**
	 * Creates an adapter for the <code>target</code>.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param target the object to adapt.
	 * @return the adapter for the <code>target</code>.
	 * @generated
	 */
	@Override
	public Adapter createAdapter(Notifier target) {
		return modelSwitch.doSwitch((EObject)target);
	}


	/**
	 * Creates a new adapter for an object of class '{@link com.irtsaintexupery.fiacre.instance.fiacreinstance.InstanceModel <em>Instance Model</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see com.irtsaintexupery.fiacre.instance.fiacreinstance.InstanceModel
	 * @generated
	 */
	public Adapter createInstanceModelAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link com.irtsaintexupery.fiacre.instance.fiacreinstance.StatementBlock <em>Statement Block</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see com.irtsaintexupery.fiacre.instance.fiacreinstance.StatementBlock
	 * @generated
	 */
	public Adapter createStatementBlockAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link com.irtsaintexupery.fiacre.instance.fiacreinstance.ExecutedStatementBlock <em>Executed Statement Block</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see com.irtsaintexupery.fiacre.instance.fiacreinstance.ExecutedStatementBlock
	 * @generated
	 */
	public Adapter createExecutedStatementBlockAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link com.irtsaintexupery.fiacre.instance.fiacreinstance.ExecutableStatementBlock <em>Executable Statement Block</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see com.irtsaintexupery.fiacre.instance.fiacreinstance.ExecutableStatementBlock
	 * @generated
	 */
	public Adapter createExecutableStatementBlockAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link com.irtsaintexupery.fiacre.instance.fiacreinstance.FireableStatementBlock <em>Fireable Statement Block</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see com.irtsaintexupery.fiacre.instance.fiacreinstance.FireableStatementBlock
	 * @generated
	 */
	public Adapter createFireableStatementBlockAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link com.irtsaintexupery.fiacre.instance.fiacreinstance.EnabledStatementBlock <em>Enabled Statement Block</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see com.irtsaintexupery.fiacre.instance.fiacreinstance.EnabledStatementBlock
	 * @generated
	 */
	public Adapter createEnabledStatementBlockAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link com.irtsaintexupery.fiacre.instance.fiacreinstance.BlockInstance <em>Block Instance</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see com.irtsaintexupery.fiacre.instance.fiacreinstance.BlockInstance
	 * @generated
	 */
	public Adapter createBlockInstanceAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link com.irtsaintexupery.fiacre.instance.fiacreinstance.CompositionInstance <em>Composition Instance</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see com.irtsaintexupery.fiacre.instance.fiacreinstance.CompositionInstance
	 * @generated
	 */
	public Adapter createCompositionInstanceAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link com.irtsaintexupery.fiacre.instance.fiacreinstance.DeclarationInstance <em>Declaration Instance</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see com.irtsaintexupery.fiacre.instance.fiacreinstance.DeclarationInstance
	 * @generated
	 */
	public Adapter createDeclarationInstanceAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link com.irtsaintexupery.fiacre.instance.fiacreinstance.ComponentDeclarationInstance <em>Component Declaration Instance</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see com.irtsaintexupery.fiacre.instance.fiacreinstance.ComponentDeclarationInstance
	 * @generated
	 */
	public Adapter createComponentDeclarationInstanceAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link com.irtsaintexupery.fiacre.instance.fiacreinstance.ProcessDeclarationInstance <em>Process Declaration Instance</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see com.irtsaintexupery.fiacre.instance.fiacreinstance.ProcessDeclarationInstance
	 * @generated
	 */
	public Adapter createProcessDeclarationInstanceAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link com.irtsaintexupery.fiacre.instance.fiacreinstance.InstanceStatementBlock <em>Instance Statement Block</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see com.irtsaintexupery.fiacre.instance.fiacreinstance.InstanceStatementBlock
	 * @generated
	 */
	public Adapter createInstanceStatementBlockAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link com.irtsaintexupery.fiacre.instance.fiacreinstance.InstanceExecutedStatementBlock <em>Instance Executed Statement Block</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see com.irtsaintexupery.fiacre.instance.fiacreinstance.InstanceExecutedStatementBlock
	 * @generated
	 */
	public Adapter createInstanceExecutedStatementBlockAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link com.irtsaintexupery.fiacre.instance.fiacreinstance.InstanceExecutableStatementBlock <em>Instance Executable Statement Block</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see com.irtsaintexupery.fiacre.instance.fiacreinstance.InstanceExecutableStatementBlock
	 * @generated
	 */
	public Adapter createInstanceExecutableStatementBlockAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link com.irtsaintexupery.fiacre.instance.fiacreinstance.InstanceFireableStatementBlock <em>Instance Fireable Statement Block</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see com.irtsaintexupery.fiacre.instance.fiacreinstance.InstanceFireableStatementBlock
	 * @generated
	 */
	public Adapter createInstanceFireableStatementBlockAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link com.irtsaintexupery.fiacre.instance.fiacreinstance.InstanceEnabledStatementBlock <em>Instance Enabled Statement Block</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see com.irtsaintexupery.fiacre.instance.fiacreinstance.InstanceEnabledStatementBlock
	 * @generated
	 */
	public Adapter createInstanceEnabledStatementBlockAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link com.irtsaintexupery.fiacre.instance.fiacreinstance.VariableDeclarationInstance <em>Variable Declaration Instance</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see com.irtsaintexupery.fiacre.instance.fiacreinstance.VariableDeclarationInstance
	 * @generated
	 */
	public Adapter createVariableDeclarationInstanceAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for the default case.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @generated
	 */
	public Adapter createEObjectAdapter() {
		return null;
	}

} //FiacreinstanceAdapterFactory
