/**
 */
package com.irtsaintexupery.fiacre.simulator.msc.msc;

import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.EReference;

/**
 * <!-- begin-user-doc -->
 * The <b>Package</b> for the model.
 * It contains accessors for the meta objects to represent
 * <ul>
 *   <li>each class,</li>
 *   <li>each feature of each class,</li>
 *   <li>each operation of each class,</li>
 *   <li>each enum,</li>
 *   <li>and each data type</li>
 * </ul>
 * <!-- end-user-doc -->
 * @see com.irtsaintexupery.fiacre.simulator.msc.msc.MscFactory
 * @model kind="package"
 * @generated
 */
public interface MscPackage extends EPackage {
	/**
	 * The package name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNAME = "msc";

	/**
	 * The package namespace URI.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_URI = "http://irtsaintexupery.com/msc";

	/**
	 * The package namespace name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_PREFIX = "msc";

	/**
	 * The singleton instance of the package.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	MscPackage eINSTANCE = com.irtsaintexupery.fiacre.simulator.msc.msc.impl.MscPackageImpl.init();

	/**
	 * The meta object id for the '{@link com.irtsaintexupery.fiacre.simulator.msc.msc.impl.MSCImpl <em>MSC</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.irtsaintexupery.fiacre.simulator.msc.msc.impl.MSCImpl
	 * @see com.irtsaintexupery.fiacre.simulator.msc.msc.impl.MscPackageImpl#getMSC()
	 * @generated
	 */
	int MSC = 0;

	/**
	 * The feature id for the '<em><b>Sites</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MSC__SITES = 0;

	/**
	 * The feature id for the '<em><b>Steps</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MSC__STEPS = 1;

	/**
	 * The number of structural features of the '<em>MSC</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MSC_FEATURE_COUNT = 2;

	/**
	 * The number of operations of the '<em>MSC</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MSC_OPERATION_COUNT = 0;

	/**
	 * The meta object id for the '{@link com.irtsaintexupery.fiacre.simulator.msc.msc.impl.SiteImpl <em>Site</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.irtsaintexupery.fiacre.simulator.msc.msc.impl.SiteImpl
	 * @see com.irtsaintexupery.fiacre.simulator.msc.msc.impl.MscPackageImpl#getSite()
	 * @generated
	 */
	int SITE = 1;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SITE__NAME = 0;

	/**
	 * The feature id for the '<em><b>Current State</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SITE__CURRENT_STATE = 1;

	/**
	 * The number of structural features of the '<em>Site</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SITE_FEATURE_COUNT = 2;

	/**
	 * The number of operations of the '<em>Site</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SITE_OPERATION_COUNT = 0;

	/**
	 * The meta object id for the '{@link com.irtsaintexupery.fiacre.simulator.msc.msc.impl.StepImpl <em>Step</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.irtsaintexupery.fiacre.simulator.msc.msc.impl.StepImpl
	 * @see com.irtsaintexupery.fiacre.simulator.msc.msc.impl.MscPackageImpl#getStep()
	 * @generated
	 */
	int STEP = 2;

	/**
	 * The feature id for the '<em><b>Micro Steps</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STEP__MICRO_STEPS = 0;

	/**
	 * The number of structural features of the '<em>Step</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STEP_FEATURE_COUNT = 1;

	/**
	 * The number of operations of the '<em>Step</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STEP_OPERATION_COUNT = 0;

	/**
	 * The meta object id for the '{@link com.irtsaintexupery.fiacre.simulator.msc.msc.impl.MicroStepImpl <em>Micro Step</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.irtsaintexupery.fiacre.simulator.msc.msc.impl.MicroStepImpl
	 * @see com.irtsaintexupery.fiacre.simulator.msc.msc.impl.MscPackageImpl#getMicroStep()
	 * @generated
	 */
	int MICRO_STEP = 3;

	/**
	 * The feature id for the '<em><b>Time</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MICRO_STEP__TIME = 0;

	/**
	 * The number of structural features of the '<em>Micro Step</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MICRO_STEP_FEATURE_COUNT = 1;

	/**
	 * The number of operations of the '<em>Micro Step</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MICRO_STEP_OPERATION_COUNT = 0;

	/**
	 * The meta object id for the '{@link com.irtsaintexupery.fiacre.simulator.msc.msc.impl.EnterStateStepImpl <em>Enter State Step</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.irtsaintexupery.fiacre.simulator.msc.msc.impl.EnterStateStepImpl
	 * @see com.irtsaintexupery.fiacre.simulator.msc.msc.impl.MscPackageImpl#getEnterStateStep()
	 * @generated
	 */
	int ENTER_STATE_STEP = 4;

	/**
	 * The feature id for the '<em><b>Time</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENTER_STATE_STEP__TIME = MICRO_STEP__TIME;

	/**
	 * The feature id for the '<em><b>State Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENTER_STATE_STEP__STATE_NAME = MICRO_STEP_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Site</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENTER_STATE_STEP__SITE = MICRO_STEP_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>Enter State Step</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENTER_STATE_STEP_FEATURE_COUNT = MICRO_STEP_FEATURE_COUNT + 2;

	/**
	 * The number of operations of the '<em>Enter State Step</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENTER_STATE_STEP_OPERATION_COUNT = MICRO_STEP_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.irtsaintexupery.fiacre.simulator.msc.msc.impl.SynchronisationStepImpl <em>Synchronisation Step</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.irtsaintexupery.fiacre.simulator.msc.msc.impl.SynchronisationStepImpl
	 * @see com.irtsaintexupery.fiacre.simulator.msc.msc.impl.MscPackageImpl#getSynchronisationStep()
	 * @generated
	 */
	int SYNCHRONISATION_STEP = 5;

	/**
	 * The feature id for the '<em><b>Time</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SYNCHRONISATION_STEP__TIME = MICRO_STEP__TIME;

	/**
	 * The feature id for the '<em><b>Sites</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SYNCHRONISATION_STEP__SITES = MICRO_STEP_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Synchronisation Step</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SYNCHRONISATION_STEP_FEATURE_COUNT = MICRO_STEP_FEATURE_COUNT + 1;

	/**
	 * The number of operations of the '<em>Synchronisation Step</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SYNCHRONISATION_STEP_OPERATION_COUNT = MICRO_STEP_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.irtsaintexupery.fiacre.simulator.msc.msc.impl.SendStepImpl <em>Send Step</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.irtsaintexupery.fiacre.simulator.msc.msc.impl.SendStepImpl
	 * @see com.irtsaintexupery.fiacre.simulator.msc.msc.impl.MscPackageImpl#getSendStep()
	 * @generated
	 */
	int SEND_STEP = 6;

	/**
	 * The feature id for the '<em><b>Time</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SEND_STEP__TIME = MICRO_STEP__TIME;

	/**
	 * The feature id for the '<em><b>Sender Sites</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SEND_STEP__SENDER_SITES = MICRO_STEP_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Receiver Sites</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SEND_STEP__RECEIVER_SITES = MICRO_STEP_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>Send Step</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SEND_STEP_FEATURE_COUNT = MICRO_STEP_FEATURE_COUNT + 2;

	/**
	 * The number of operations of the '<em>Send Step</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SEND_STEP_OPERATION_COUNT = MICRO_STEP_OPERATION_COUNT + 0;


	/**
	 * Returns the meta object for class '{@link com.irtsaintexupery.fiacre.simulator.msc.msc.MSC <em>MSC</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>MSC</em>'.
	 * @see com.irtsaintexupery.fiacre.simulator.msc.msc.MSC
	 * @generated
	 */
	EClass getMSC();

	/**
	 * Returns the meta object for the containment reference list '{@link com.irtsaintexupery.fiacre.simulator.msc.msc.MSC#getSites <em>Sites</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Sites</em>'.
	 * @see com.irtsaintexupery.fiacre.simulator.msc.msc.MSC#getSites()
	 * @see #getMSC()
	 * @generated
	 */
	EReference getMSC_Sites();

	/**
	 * Returns the meta object for the containment reference list '{@link com.irtsaintexupery.fiacre.simulator.msc.msc.MSC#getSteps <em>Steps</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Steps</em>'.
	 * @see com.irtsaintexupery.fiacre.simulator.msc.msc.MSC#getSteps()
	 * @see #getMSC()
	 * @generated
	 */
	EReference getMSC_Steps();

	/**
	 * Returns the meta object for class '{@link com.irtsaintexupery.fiacre.simulator.msc.msc.Site <em>Site</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Site</em>'.
	 * @see com.irtsaintexupery.fiacre.simulator.msc.msc.Site
	 * @generated
	 */
	EClass getSite();

	/**
	 * Returns the meta object for the attribute '{@link com.irtsaintexupery.fiacre.simulator.msc.msc.Site#getName <em>Name</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Name</em>'.
	 * @see com.irtsaintexupery.fiacre.simulator.msc.msc.Site#getName()
	 * @see #getSite()
	 * @generated
	 */
	EAttribute getSite_Name();

	/**
	 * Returns the meta object for the attribute '{@link com.irtsaintexupery.fiacre.simulator.msc.msc.Site#getCurrentState <em>Current State</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Current State</em>'.
	 * @see com.irtsaintexupery.fiacre.simulator.msc.msc.Site#getCurrentState()
	 * @see #getSite()
	 * @generated
	 */
	EAttribute getSite_CurrentState();

	/**
	 * Returns the meta object for class '{@link com.irtsaintexupery.fiacre.simulator.msc.msc.Step <em>Step</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Step</em>'.
	 * @see com.irtsaintexupery.fiacre.simulator.msc.msc.Step
	 * @generated
	 */
	EClass getStep();

	/**
	 * Returns the meta object for the containment reference list '{@link com.irtsaintexupery.fiacre.simulator.msc.msc.Step#getMicroSteps <em>Micro Steps</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Micro Steps</em>'.
	 * @see com.irtsaintexupery.fiacre.simulator.msc.msc.Step#getMicroSteps()
	 * @see #getStep()
	 * @generated
	 */
	EReference getStep_MicroSteps();

	/**
	 * Returns the meta object for class '{@link com.irtsaintexupery.fiacre.simulator.msc.msc.MicroStep <em>Micro Step</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Micro Step</em>'.
	 * @see com.irtsaintexupery.fiacre.simulator.msc.msc.MicroStep
	 * @generated
	 */
	EClass getMicroStep();

	/**
	 * Returns the meta object for the attribute '{@link com.irtsaintexupery.fiacre.simulator.msc.msc.MicroStep#getTime <em>Time</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Time</em>'.
	 * @see com.irtsaintexupery.fiacre.simulator.msc.msc.MicroStep#getTime()
	 * @see #getMicroStep()
	 * @generated
	 */
	EAttribute getMicroStep_Time();

	/**
	 * Returns the meta object for class '{@link com.irtsaintexupery.fiacre.simulator.msc.msc.EnterStateStep <em>Enter State Step</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Enter State Step</em>'.
	 * @see com.irtsaintexupery.fiacre.simulator.msc.msc.EnterStateStep
	 * @generated
	 */
	EClass getEnterStateStep();

	/**
	 * Returns the meta object for the attribute '{@link com.irtsaintexupery.fiacre.simulator.msc.msc.EnterStateStep#getStateName <em>State Name</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>State Name</em>'.
	 * @see com.irtsaintexupery.fiacre.simulator.msc.msc.EnterStateStep#getStateName()
	 * @see #getEnterStateStep()
	 * @generated
	 */
	EAttribute getEnterStateStep_StateName();

	/**
	 * Returns the meta object for the reference '{@link com.irtsaintexupery.fiacre.simulator.msc.msc.EnterStateStep#getSite <em>Site</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Site</em>'.
	 * @see com.irtsaintexupery.fiacre.simulator.msc.msc.EnterStateStep#getSite()
	 * @see #getEnterStateStep()
	 * @generated
	 */
	EReference getEnterStateStep_Site();

	/**
	 * Returns the meta object for class '{@link com.irtsaintexupery.fiacre.simulator.msc.msc.SynchronisationStep <em>Synchronisation Step</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Synchronisation Step</em>'.
	 * @see com.irtsaintexupery.fiacre.simulator.msc.msc.SynchronisationStep
	 * @generated
	 */
	EClass getSynchronisationStep();

	/**
	 * Returns the meta object for the reference list '{@link com.irtsaintexupery.fiacre.simulator.msc.msc.SynchronisationStep#getSites <em>Sites</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Sites</em>'.
	 * @see com.irtsaintexupery.fiacre.simulator.msc.msc.SynchronisationStep#getSites()
	 * @see #getSynchronisationStep()
	 * @generated
	 */
	EReference getSynchronisationStep_Sites();

	/**
	 * Returns the meta object for class '{@link com.irtsaintexupery.fiacre.simulator.msc.msc.SendStep <em>Send Step</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Send Step</em>'.
	 * @see com.irtsaintexupery.fiacre.simulator.msc.msc.SendStep
	 * @generated
	 */
	EClass getSendStep();

	/**
	 * Returns the meta object for the reference list '{@link com.irtsaintexupery.fiacre.simulator.msc.msc.SendStep#getSenderSites <em>Sender Sites</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Sender Sites</em>'.
	 * @see com.irtsaintexupery.fiacre.simulator.msc.msc.SendStep#getSenderSites()
	 * @see #getSendStep()
	 * @generated
	 */
	EReference getSendStep_SenderSites();

	/**
	 * Returns the meta object for the reference list '{@link com.irtsaintexupery.fiacre.simulator.msc.msc.SendStep#getReceiverSites <em>Receiver Sites</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Receiver Sites</em>'.
	 * @see com.irtsaintexupery.fiacre.simulator.msc.msc.SendStep#getReceiverSites()
	 * @see #getSendStep()
	 * @generated
	 */
	EReference getSendStep_ReceiverSites();

	/**
	 * Returns the factory that creates the instances of the model.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the factory that creates the instances of the model.
	 * @generated
	 */
	MscFactory getMscFactory();

	/**
	 * <!-- begin-user-doc -->
	 * Defines literals for the meta objects that represent
	 * <ul>
	 *   <li>each class,</li>
	 *   <li>each feature of each class,</li>
	 *   <li>each operation of each class,</li>
	 *   <li>each enum,</li>
	 *   <li>and each data type</li>
	 * </ul>
	 * <!-- end-user-doc -->
	 * @generated
	 */
	interface Literals {
		/**
		 * The meta object literal for the '{@link com.irtsaintexupery.fiacre.simulator.msc.msc.impl.MSCImpl <em>MSC</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.irtsaintexupery.fiacre.simulator.msc.msc.impl.MSCImpl
		 * @see com.irtsaintexupery.fiacre.simulator.msc.msc.impl.MscPackageImpl#getMSC()
		 * @generated
		 */
		EClass MSC = eINSTANCE.getMSC();

		/**
		 * The meta object literal for the '<em><b>Sites</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference MSC__SITES = eINSTANCE.getMSC_Sites();

		/**
		 * The meta object literal for the '<em><b>Steps</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference MSC__STEPS = eINSTANCE.getMSC_Steps();

		/**
		 * The meta object literal for the '{@link com.irtsaintexupery.fiacre.simulator.msc.msc.impl.SiteImpl <em>Site</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.irtsaintexupery.fiacre.simulator.msc.msc.impl.SiteImpl
		 * @see com.irtsaintexupery.fiacre.simulator.msc.msc.impl.MscPackageImpl#getSite()
		 * @generated
		 */
		EClass SITE = eINSTANCE.getSite();

		/**
		 * The meta object literal for the '<em><b>Name</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute SITE__NAME = eINSTANCE.getSite_Name();

		/**
		 * The meta object literal for the '<em><b>Current State</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute SITE__CURRENT_STATE = eINSTANCE.getSite_CurrentState();

		/**
		 * The meta object literal for the '{@link com.irtsaintexupery.fiacre.simulator.msc.msc.impl.StepImpl <em>Step</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.irtsaintexupery.fiacre.simulator.msc.msc.impl.StepImpl
		 * @see com.irtsaintexupery.fiacre.simulator.msc.msc.impl.MscPackageImpl#getStep()
		 * @generated
		 */
		EClass STEP = eINSTANCE.getStep();

		/**
		 * The meta object literal for the '<em><b>Micro Steps</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference STEP__MICRO_STEPS = eINSTANCE.getStep_MicroSteps();

		/**
		 * The meta object literal for the '{@link com.irtsaintexupery.fiacre.simulator.msc.msc.impl.MicroStepImpl <em>Micro Step</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.irtsaintexupery.fiacre.simulator.msc.msc.impl.MicroStepImpl
		 * @see com.irtsaintexupery.fiacre.simulator.msc.msc.impl.MscPackageImpl#getMicroStep()
		 * @generated
		 */
		EClass MICRO_STEP = eINSTANCE.getMicroStep();

		/**
		 * The meta object literal for the '<em><b>Time</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute MICRO_STEP__TIME = eINSTANCE.getMicroStep_Time();

		/**
		 * The meta object literal for the '{@link com.irtsaintexupery.fiacre.simulator.msc.msc.impl.EnterStateStepImpl <em>Enter State Step</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.irtsaintexupery.fiacre.simulator.msc.msc.impl.EnterStateStepImpl
		 * @see com.irtsaintexupery.fiacre.simulator.msc.msc.impl.MscPackageImpl#getEnterStateStep()
		 * @generated
		 */
		EClass ENTER_STATE_STEP = eINSTANCE.getEnterStateStep();

		/**
		 * The meta object literal for the '<em><b>State Name</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute ENTER_STATE_STEP__STATE_NAME = eINSTANCE.getEnterStateStep_StateName();

		/**
		 * The meta object literal for the '<em><b>Site</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference ENTER_STATE_STEP__SITE = eINSTANCE.getEnterStateStep_Site();

		/**
		 * The meta object literal for the '{@link com.irtsaintexupery.fiacre.simulator.msc.msc.impl.SynchronisationStepImpl <em>Synchronisation Step</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.irtsaintexupery.fiacre.simulator.msc.msc.impl.SynchronisationStepImpl
		 * @see com.irtsaintexupery.fiacre.simulator.msc.msc.impl.MscPackageImpl#getSynchronisationStep()
		 * @generated
		 */
		EClass SYNCHRONISATION_STEP = eINSTANCE.getSynchronisationStep();

		/**
		 * The meta object literal for the '<em><b>Sites</b></em>' reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference SYNCHRONISATION_STEP__SITES = eINSTANCE.getSynchronisationStep_Sites();

		/**
		 * The meta object literal for the '{@link com.irtsaintexupery.fiacre.simulator.msc.msc.impl.SendStepImpl <em>Send Step</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.irtsaintexupery.fiacre.simulator.msc.msc.impl.SendStepImpl
		 * @see com.irtsaintexupery.fiacre.simulator.msc.msc.impl.MscPackageImpl#getSendStep()
		 * @generated
		 */
		EClass SEND_STEP = eINSTANCE.getSendStep();

		/**
		 * The meta object literal for the '<em><b>Sender Sites</b></em>' reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference SEND_STEP__SENDER_SITES = eINSTANCE.getSendStep_SenderSites();

		/**
		 * The meta object literal for the '<em><b>Receiver Sites</b></em>' reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference SEND_STEP__RECEIVER_SITES = eINSTANCE.getSendStep_ReceiverSites();

	}

} //MscPackage
