/**
 */
package com.irtsaintexupery.fiacre.simulator.msc.msc.util;

import com.irtsaintexupery.fiacre.simulator.msc.msc.*;

import org.eclipse.emf.common.notify.Adapter;
import org.eclipse.emf.common.notify.Notifier;

import org.eclipse.emf.common.notify.impl.AdapterFactoryImpl;

import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * The <b>Adapter Factory</b> for the model.
 * It provides an adapter <code>createXXX</code> method for each class of the model.
 * <!-- end-user-doc -->
 * @see com.irtsaintexupery.fiacre.simulator.msc.msc.MscPackage
 * @generated
 */
public class MscAdapterFactory extends AdapterFactoryImpl {
	/**
	 * The cached model package.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected static MscPackage modelPackage;

	/**
	 * Creates an instance of the adapter factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public MscAdapterFactory() {
		if (modelPackage == null) {
			modelPackage = MscPackage.eINSTANCE;
		}
	}

	/**
	 * Returns whether this factory is applicable for the type of the object.
	 * <!-- begin-user-doc -->
	 * This implementation returns <code>true</code> if the object is either the model's package or is an instance object of the model.
	 * <!-- end-user-doc -->
	 * @return whether this factory is applicable for the type of the object.
	 * @generated
	 */
	@Override
	public boolean isFactoryForType(Object object) {
		if (object == modelPackage) {
			return true;
		}
		if (object instanceof EObject) {
			return ((EObject)object).eClass().getEPackage() == modelPackage;
		}
		return false;
	}

	/**
	 * The switch that delegates to the <code>createXXX</code> methods.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected MscSwitch<Adapter> modelSwitch =
		new MscSwitch<Adapter>() {
			@Override
			public Adapter caseMSC(MSC object) {
				return createMSCAdapter();
			}
			@Override
			public Adapter caseSite(Site object) {
				return createSiteAdapter();
			}
			@Override
			public Adapter caseStep(Step object) {
				return createStepAdapter();
			}
			@Override
			public Adapter caseMicroStep(MicroStep object) {
				return createMicroStepAdapter();
			}
			@Override
			public Adapter caseEnterStateStep(EnterStateStep object) {
				return createEnterStateStepAdapter();
			}
			@Override
			public Adapter caseSynchronisationStep(SynchronisationStep object) {
				return createSynchronisationStepAdapter();
			}
			@Override
			public Adapter caseSendStep(SendStep object) {
				return createSendStepAdapter();
			}
			@Override
			public Adapter defaultCase(EObject object) {
				return createEObjectAdapter();
			}
		};

	/**
	 * Creates an adapter for the <code>target</code>.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param target the object to adapt.
	 * @return the adapter for the <code>target</code>.
	 * @generated
	 */
	@Override
	public Adapter createAdapter(Notifier target) {
		return modelSwitch.doSwitch((EObject)target);
	}


	/**
	 * Creates a new adapter for an object of class '{@link com.irtsaintexupery.fiacre.simulator.msc.msc.MSC <em>MSC</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see com.irtsaintexupery.fiacre.simulator.msc.msc.MSC
	 * @generated
	 */
	public Adapter createMSCAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link com.irtsaintexupery.fiacre.simulator.msc.msc.Site <em>Site</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see com.irtsaintexupery.fiacre.simulator.msc.msc.Site
	 * @generated
	 */
	public Adapter createSiteAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link com.irtsaintexupery.fiacre.simulator.msc.msc.Step <em>Step</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see com.irtsaintexupery.fiacre.simulator.msc.msc.Step
	 * @generated
	 */
	public Adapter createStepAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link com.irtsaintexupery.fiacre.simulator.msc.msc.MicroStep <em>Micro Step</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see com.irtsaintexupery.fiacre.simulator.msc.msc.MicroStep
	 * @generated
	 */
	public Adapter createMicroStepAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link com.irtsaintexupery.fiacre.simulator.msc.msc.EnterStateStep <em>Enter State Step</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see com.irtsaintexupery.fiacre.simulator.msc.msc.EnterStateStep
	 * @generated
	 */
	public Adapter createEnterStateStepAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link com.irtsaintexupery.fiacre.simulator.msc.msc.SynchronisationStep <em>Synchronisation Step</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see com.irtsaintexupery.fiacre.simulator.msc.msc.SynchronisationStep
	 * @generated
	 */
	public Adapter createSynchronisationStepAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link com.irtsaintexupery.fiacre.simulator.msc.msc.SendStep <em>Send Step</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see com.irtsaintexupery.fiacre.simulator.msc.msc.SendStep
	 * @generated
	 */
	public Adapter createSendStepAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for the default case.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @generated
	 */
	public Adapter createEObjectAdapter() {
		return null;
	}

} //MscAdapterFactory
