/*******************************************************************************
 * Copyright (c) 2015, 2016 CNRS, IRIT, IRT AESE (IRT Saint Exupéry).
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the LGPL 3.0
 * which accompanies this distribution, and is available at
 * https://www.gnu.org/licenses/lgpl-3.0-standalone.html
 *
 * Contributors:
 *      Faiez Zalila - initial API and implementation and/or initial documentation
 *******************************************************************************/
/**
 * generated by Xtext 2.10.0
 */
package fr.irit.fiacre.xtext.fiacre.provider;


import fr.irit.fiacre.xtext.fiacre.ArrayAccessPattern;
import fr.irit.fiacre.xtext.fiacre.FiacreFactory;
import fr.irit.fiacre.xtext.fiacre.FiacrePackage;

import java.util.Collection;
import java.util.List;

import org.eclipse.emf.common.notify.AdapterFactory;
import org.eclipse.emf.common.notify.Notification;

import org.eclipse.emf.ecore.EStructuralFeature;

import org.eclipse.emf.edit.provider.IItemPropertyDescriptor;
import org.eclipse.emf.edit.provider.ViewerNotification;

/**
 * This is the item provider adapter for a {@link fr.irit.fiacre.xtext.fiacre.ArrayAccessPattern} object.
 * <!-- begin-user-doc -->
 * <!-- end-user-doc -->
 * @generated
 */
public class ArrayAccessPatternItemProvider extends IdentifierPatternItemProvider {
	/**
	 * This constructs an instance from a factory and a notifier.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ArrayAccessPatternItemProvider(AdapterFactory adapterFactory) {
		super(adapterFactory);
	}

	/**
	 * This returns the property descriptors for the adapted class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public List<IItemPropertyDescriptor> getPropertyDescriptors(Object object) {
		if (itemPropertyDescriptors == null) {
			super.getPropertyDescriptors(object);

		}
		return itemPropertyDescriptors;
	}

	/**
	 * This specifies how to implement {@link #getChildren} and is used to deduce an appropriate feature for an
	 * {@link org.eclipse.emf.edit.command.AddCommand}, {@link org.eclipse.emf.edit.command.RemoveCommand} or
	 * {@link org.eclipse.emf.edit.command.MoveCommand} in {@link #createCommand}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Collection<? extends EStructuralFeature> getChildrenFeatures(Object object) {
		if (childrenFeatures == null) {
			super.getChildrenFeatures(object);
			childrenFeatures.add(FiacrePackage.eINSTANCE.getArrayAccessPattern_Source());
			childrenFeatures.add(FiacrePackage.eINSTANCE.getArrayAccessPattern_Index());
		}
		return childrenFeatures;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EStructuralFeature getChildFeature(Object object, Object child) {
		// Check the type of the specified child object and return the proper feature to use for
		// adding (see {@link AddCommand}) it as a child.

		return super.getChildFeature(object, child);
	}

	/**
	 * This returns ArrayAccessPattern.gif.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object getImage(Object object) {
		return overlayImage(object, getResourceLocator().getImage("full/obj16/ArrayAccessPattern"));
	}

	/**
	 * This returns the label text for the adapted class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String getText(Object object) {
		return getString("_UI_ArrayAccessPattern_type");
	}
	

	/**
	 * This handles model notifications by calling {@link #updateChildren} to update any cached
	 * children and by creating a viewer notification, which it passes to {@link #fireNotifyChanged}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void notifyChanged(Notification notification) {
		updateChildren(notification);

		switch (notification.getFeatureID(ArrayAccessPattern.class)) {
			case FiacrePackage.ARRAY_ACCESS_PATTERN__SOURCE:
			case FiacrePackage.ARRAY_ACCESS_PATTERN__INDEX:
				fireNotifyChanged(new ViewerNotification(notification, notification.getNotifier(), true, false));
				return;
		}
		super.notifyChanged(notification);
	}

	/**
	 * This adds {@link org.eclipse.emf.edit.command.CommandParameter}s describing the children
	 * that can be created under this object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected void collectNewChildDescriptors(Collection<Object> newChildDescriptors, Object object) {
		super.collectNewChildDescriptors(newChildDescriptors, object);

		newChildDescriptors.add
			(createChildParameter
				(FiacrePackage.eINSTANCE.getArrayAccessPattern_Source(),
				 FiacreFactory.eINSTANCE.createIdentifierPattern()));

		newChildDescriptors.add
			(createChildParameter
				(FiacrePackage.eINSTANCE.getArrayAccessPattern_Source(),
				 FiacreFactory.eINSTANCE.createConstructorPattern()));

		newChildDescriptors.add
			(createChildParameter
				(FiacrePackage.eINSTANCE.getArrayAccessPattern_Source(),
				 FiacreFactory.eINSTANCE.createArrayAccessPattern()));

		newChildDescriptors.add
			(createChildParameter
				(FiacrePackage.eINSTANCE.getArrayAccessPattern_Source(),
				 FiacreFactory.eINSTANCE.createRecordAccessPattern()));

		newChildDescriptors.add
			(createChildParameter
				(FiacrePackage.eINSTANCE.getArrayAccessPattern_Index(),
				 FiacreFactory.eINSTANCE.createExpression()));

		newChildDescriptors.add
			(createChildParameter
				(FiacrePackage.eINSTANCE.getArrayAccessPattern_Index(),
				 FiacreFactory.eINSTANCE.createReferenceExpression()));

		newChildDescriptors.add
			(createChildParameter
				(FiacrePackage.eINSTANCE.getArrayAccessPattern_Index(),
				 FiacreFactory.eINSTANCE.createIdentifierExpression()));

		newChildDescriptors.add
			(createChildParameter
				(FiacrePackage.eINSTANCE.getArrayAccessPattern_Index(),
				 FiacreFactory.eINSTANCE.createRecordExpression()));

		newChildDescriptors.add
			(createChildParameter
				(FiacrePackage.eINSTANCE.getArrayAccessPattern_Index(),
				 FiacreFactory.eINSTANCE.createArrayExpression()));

		newChildDescriptors.add
			(createChildParameter
				(FiacrePackage.eINSTANCE.getArrayAccessPattern_Index(),
				 FiacreFactory.eINSTANCE.createQueueExpression()));

		newChildDescriptors.add
			(createChildParameter
				(FiacrePackage.eINSTANCE.getArrayAccessPattern_Index(),
				 FiacreFactory.eINSTANCE.createEnqueueExpression()));

		newChildDescriptors.add
			(createChildParameter
				(FiacrePackage.eINSTANCE.getArrayAccessPattern_Index(),
				 FiacreFactory.eINSTANCE.createAppendExpression()));

		newChildDescriptors.add
			(createChildParameter
				(FiacrePackage.eINSTANCE.getArrayAccessPattern_Index(),
				 FiacreFactory.eINSTANCE.createLiteralExpression()));

		newChildDescriptors.add
			(createChildParameter
				(FiacrePackage.eINSTANCE.getArrayAccessPattern_Index(),
				 FiacreFactory.eINSTANCE.createBooleanLiteral()));

		newChildDescriptors.add
			(createChildParameter
				(FiacrePackage.eINSTANCE.getArrayAccessPattern_Index(),
				 FiacreFactory.eINSTANCE.createNaturalLiteral()));

		newChildDescriptors.add
			(createChildParameter
				(FiacrePackage.eINSTANCE.getArrayAccessPattern_Index(),
				 FiacreFactory.eINSTANCE.createAllExpression()));

		newChildDescriptors.add
			(createChildParameter
				(FiacrePackage.eINSTANCE.getArrayAccessPattern_Index(),
				 FiacreFactory.eINSTANCE.createExistsExpression()));

		newChildDescriptors.add
			(createChildParameter
				(FiacrePackage.eINSTANCE.getArrayAccessPattern_Index(),
				 FiacreFactory.eINSTANCE.createConditional()));

		newChildDescriptors.add
			(createChildParameter
				(FiacrePackage.eINSTANCE.getArrayAccessPattern_Index(),
				 FiacreFactory.eINSTANCE.createDisjunction()));

		newChildDescriptors.add
			(createChildParameter
				(FiacrePackage.eINSTANCE.getArrayAccessPattern_Index(),
				 FiacreFactory.eINSTANCE.createImplication()));

		newChildDescriptors.add
			(createChildParameter
				(FiacrePackage.eINSTANCE.getArrayAccessPattern_Index(),
				 FiacreFactory.eINSTANCE.createConjunction()));

		newChildDescriptors.add
			(createChildParameter
				(FiacrePackage.eINSTANCE.getArrayAccessPattern_Index(),
				 FiacreFactory.eINSTANCE.createComparisonEqual()));

		newChildDescriptors.add
			(createChildParameter
				(FiacrePackage.eINSTANCE.getArrayAccessPattern_Index(),
				 FiacreFactory.eINSTANCE.createComparisonNotEqual()));

		newChildDescriptors.add
			(createChildParameter
				(FiacrePackage.eINSTANCE.getArrayAccessPattern_Index(),
				 FiacreFactory.eINSTANCE.createComparisonLesser()));

		newChildDescriptors.add
			(createChildParameter
				(FiacrePackage.eINSTANCE.getArrayAccessPattern_Index(),
				 FiacreFactory.eINSTANCE.createComparisonLesserEqual()));

		newChildDescriptors.add
			(createChildParameter
				(FiacrePackage.eINSTANCE.getArrayAccessPattern_Index(),
				 FiacreFactory.eINSTANCE.createComparisonGreater()));

		newChildDescriptors.add
			(createChildParameter
				(FiacrePackage.eINSTANCE.getArrayAccessPattern_Index(),
				 FiacreFactory.eINSTANCE.createComparisonGreaterEqual()));

		newChildDescriptors.add
			(createChildParameter
				(FiacrePackage.eINSTANCE.getArrayAccessPattern_Index(),
				 FiacreFactory.eINSTANCE.createAddition()));

		newChildDescriptors.add
			(createChildParameter
				(FiacrePackage.eINSTANCE.getArrayAccessPattern_Index(),
				 FiacreFactory.eINSTANCE.createSubstraction()));

		newChildDescriptors.add
			(createChildParameter
				(FiacrePackage.eINSTANCE.getArrayAccessPattern_Index(),
				 FiacreFactory.eINSTANCE.createMultiplication()));

		newChildDescriptors.add
			(createChildParameter
				(FiacrePackage.eINSTANCE.getArrayAccessPattern_Index(),
				 FiacreFactory.eINSTANCE.createDivision()));

		newChildDescriptors.add
			(createChildParameter
				(FiacrePackage.eINSTANCE.getArrayAccessPattern_Index(),
				 FiacreFactory.eINSTANCE.createModulo()));

		newChildDescriptors.add
			(createChildParameter
				(FiacrePackage.eINSTANCE.getArrayAccessPattern_Index(),
				 FiacreFactory.eINSTANCE.createUnaryPlusExpression()));

		newChildDescriptors.add
			(createChildParameter
				(FiacrePackage.eINSTANCE.getArrayAccessPattern_Index(),
				 FiacreFactory.eINSTANCE.createUnaryMinusExpression()));

		newChildDescriptors.add
			(createChildParameter
				(FiacrePackage.eINSTANCE.getArrayAccessPattern_Index(),
				 FiacreFactory.eINSTANCE.createUnaryNegationExpression()));

		newChildDescriptors.add
			(createChildParameter
				(FiacrePackage.eINSTANCE.getArrayAccessPattern_Index(),
				 FiacreFactory.eINSTANCE.createUnaryFirstExpression()));

		newChildDescriptors.add
			(createChildParameter
				(FiacrePackage.eINSTANCE.getArrayAccessPattern_Index(),
				 FiacreFactory.eINSTANCE.createUnaryLengthExpression()));

		newChildDescriptors.add
			(createChildParameter
				(FiacrePackage.eINSTANCE.getArrayAccessPattern_Index(),
				 FiacreFactory.eINSTANCE.createUnaryCoerceExpression()));

		newChildDescriptors.add
			(createChildParameter
				(FiacrePackage.eINSTANCE.getArrayAccessPattern_Index(),
				 FiacreFactory.eINSTANCE.createUnaryFullExpression()));

		newChildDescriptors.add
			(createChildParameter
				(FiacrePackage.eINSTANCE.getArrayAccessPattern_Index(),
				 FiacreFactory.eINSTANCE.createUnaryDeQueueExpression()));

		newChildDescriptors.add
			(createChildParameter
				(FiacrePackage.eINSTANCE.getArrayAccessPattern_Index(),
				 FiacreFactory.eINSTANCE.createUnaryEmptyExpression()));

		newChildDescriptors.add
			(createChildParameter
				(FiacrePackage.eINSTANCE.getArrayAccessPattern_Index(),
				 FiacreFactory.eINSTANCE.createProjection()));

		newChildDescriptors.add
			(createChildParameter
				(FiacrePackage.eINSTANCE.getArrayAccessPattern_Index(),
				 FiacreFactory.eINSTANCE.createConstructionExpression()));

		newChildDescriptors.add
			(createChildParameter
				(FiacrePackage.eINSTANCE.getArrayAccessPattern_Index(),
				 FiacreFactory.eINSTANCE.createArrayAccessExpression()));

		newChildDescriptors.add
			(createChildParameter
				(FiacrePackage.eINSTANCE.getArrayAccessPattern_Index(),
				 FiacreFactory.eINSTANCE.createRecordAccessExpression()));

		newChildDescriptors.add
			(createChildParameter
				(FiacrePackage.eINSTANCE.getArrayAccessPattern_Index(),
				 FiacreFactory.eINSTANCE.createTrueLiteral()));

		newChildDescriptors.add
			(createChildParameter
				(FiacrePackage.eINSTANCE.getArrayAccessPattern_Index(),
				 FiacreFactory.eINSTANCE.createFalseLiteral()));
	}

}
