/*******************************************************************************
 * Copyright (c) 2015, 2016 CNRS, IRIT, IRT AESE (IRT Saint Exupéry).
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the LGPL 3.0
 * which accompanies this distribution, and is available at
 * https://www.gnu.org/licenses/lgpl-3.0-standalone.html
 *
 * Contributors:
 *      Faiez Zalila - initial API and implementation and/or initial documentation
 *******************************************************************************/
/**
 * generated by Xtext 2.10.0
 */
package fr.irit.fiacre.xtext.fiacre.provider;


import fr.irit.fiacre.xtext.fiacre.ExistsProperty;
import fr.irit.fiacre.xtext.fiacre.FiacreFactory;
import fr.irit.fiacre.xtext.fiacre.FiacrePackage;

import java.util.Collection;
import java.util.List;

import org.eclipse.emf.common.notify.AdapterFactory;
import org.eclipse.emf.common.notify.Notification;

import org.eclipse.emf.ecore.EStructuralFeature;

import org.eclipse.emf.edit.provider.IItemPropertyDescriptor;
import org.eclipse.emf.edit.provider.ViewerNotification;

/**
 * This is the item provider adapter for a {@link fr.irit.fiacre.xtext.fiacre.ExistsProperty} object.
 * <!-- begin-user-doc -->
 * <!-- end-user-doc -->
 * @generated
 */
public class ExistsPropertyItemProvider extends PropertyItemProvider {
	/**
	 * This constructs an instance from a factory and a notifier.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ExistsPropertyItemProvider(AdapterFactory adapterFactory) {
		super(adapterFactory);
	}

	/**
	 * This returns the property descriptors for the adapted class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public List<IItemPropertyDescriptor> getPropertyDescriptors(Object object) {
		if (itemPropertyDescriptors == null) {
			super.getPropertyDescriptors(object);

		}
		return itemPropertyDescriptors;
	}

	/**
	 * This specifies how to implement {@link #getChildren} and is used to deduce an appropriate feature for an
	 * {@link org.eclipse.emf.edit.command.AddCommand}, {@link org.eclipse.emf.edit.command.RemoveCommand} or
	 * {@link org.eclipse.emf.edit.command.MoveCommand} in {@link #createCommand}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Collection<? extends EStructuralFeature> getChildrenFeatures(Object object) {
		if (childrenFeatures == null) {
			super.getChildrenFeatures(object);
			childrenFeatures.add(FiacrePackage.eINSTANCE.getExistsProperty_Variable());
			childrenFeatures.add(FiacrePackage.eINSTANCE.getExistsProperty_Type());
			childrenFeatures.add(FiacrePackage.eINSTANCE.getExistsProperty_Child());
		}
		return childrenFeatures;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EStructuralFeature getChildFeature(Object object, Object child) {
		// Check the type of the specified child object and return the proper feature to use for
		// adding (see {@link AddCommand}) it as a child.

		return super.getChildFeature(object, child);
	}

	/**
	 * This returns ExistsProperty.gif.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object getImage(Object object) {
		return overlayImage(object, getResourceLocator().getImage("full/obj16/ExistsProperty"));
	}

	/**
	 * This returns the label text for the adapted class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String getText(Object object) {
		return getString("_UI_ExistsProperty_type");
	}
	

	/**
	 * This handles model notifications by calling {@link #updateChildren} to update any cached
	 * children and by creating a viewer notification, which it passes to {@link #fireNotifyChanged}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void notifyChanged(Notification notification) {
		updateChildren(notification);

		switch (notification.getFeatureID(ExistsProperty.class)) {
			case FiacrePackage.EXISTS_PROPERTY__VARIABLE:
			case FiacrePackage.EXISTS_PROPERTY__TYPE:
			case FiacrePackage.EXISTS_PROPERTY__CHILD:
				fireNotifyChanged(new ViewerNotification(notification, notification.getNotifier(), true, false));
				return;
		}
		super.notifyChanged(notification);
	}

	/**
	 * This adds {@link org.eclipse.emf.edit.command.CommandParameter}s describing the children
	 * that can be created under this object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected void collectNewChildDescriptors(Collection<Object> newChildDescriptors, Object object) {
		super.collectNewChildDescriptors(newChildDescriptors, object);

		newChildDescriptors.add
			(createChildParameter
				(FiacrePackage.eINSTANCE.getExistsProperty_Variable(),
				 FiacreFactory.eINSTANCE.createVariableDeclaration()));

		newChildDescriptors.add
			(createChildParameter
				(FiacrePackage.eINSTANCE.getExistsProperty_Type(),
				 FiacreFactory.eINSTANCE.createRangeType()));

		newChildDescriptors.add
			(createChildParameter
				(FiacrePackage.eINSTANCE.getExistsProperty_Child(),
				 FiacreFactory.eINSTANCE.createProperty()));

		newChildDescriptors.add
			(createChildParameter
				(FiacrePackage.eINSTANCE.getExistsProperty_Child(),
				 FiacreFactory.eINSTANCE.createPatternProperty()));

		newChildDescriptors.add
			(createChildParameter
				(FiacrePackage.eINSTANCE.getExistsProperty_Child(),
				 FiacreFactory.eINSTANCE.createLTLPattern()));

		newChildDescriptors.add
			(createChildParameter
				(FiacrePackage.eINSTANCE.getExistsProperty_Child(),
				 FiacreFactory.eINSTANCE.createDeadlockFreePattern()));

		newChildDescriptors.add
			(createChildParameter
				(FiacrePackage.eINSTANCE.getExistsProperty_Child(),
				 FiacreFactory.eINSTANCE.createInfinitelyOftenPattern()));

		newChildDescriptors.add
			(createChildParameter
				(FiacrePackage.eINSTANCE.getExistsProperty_Child(),
				 FiacreFactory.eINSTANCE.createMortalPattern()));

		newChildDescriptors.add
			(createChildParameter
				(FiacrePackage.eINSTANCE.getExistsProperty_Child(),
				 FiacreFactory.eINSTANCE.createPresencePattern()));

		newChildDescriptors.add
			(createChildParameter
				(FiacrePackage.eINSTANCE.getExistsProperty_Child(),
				 FiacreFactory.eINSTANCE.createAbsencePattern()));

		newChildDescriptors.add
			(createChildParameter
				(FiacrePackage.eINSTANCE.getExistsProperty_Child(),
				 FiacreFactory.eINSTANCE.createAlwaysPattern()));

		newChildDescriptors.add
			(createChildParameter
				(FiacrePackage.eINSTANCE.getExistsProperty_Child(),
				 FiacreFactory.eINSTANCE.createSequencePattern()));

		newChildDescriptors.add
			(createChildParameter
				(FiacrePackage.eINSTANCE.getExistsProperty_Child(),
				 FiacreFactory.eINSTANCE.createObservableEvent()));

		newChildDescriptors.add
			(createChildParameter
				(FiacrePackage.eINSTANCE.getExistsProperty_Child(),
				 FiacreFactory.eINSTANCE.createStateEvent()));

		newChildDescriptors.add
			(createChildParameter
				(FiacrePackage.eINSTANCE.getExistsProperty_Child(),
				 FiacreFactory.eINSTANCE.createEnterStateEvent()));

		newChildDescriptors.add
			(createChildParameter
				(FiacrePackage.eINSTANCE.getExistsProperty_Child(),
				 FiacreFactory.eINSTANCE.createLeaveStateEvent()));

		newChildDescriptors.add
			(createChildParameter
				(FiacrePackage.eINSTANCE.getExistsProperty_Child(),
				 FiacreFactory.eINSTANCE.createObservable()));

		newChildDescriptors.add
			(createChildParameter
				(FiacrePackage.eINSTANCE.getExistsProperty_Child(),
				 FiacreFactory.eINSTANCE.createPathEvent()));

		newChildDescriptors.add
			(createChildParameter
				(FiacrePackage.eINSTANCE.getExistsProperty_Child(),
				 FiacreFactory.eINSTANCE.createAllProperty()));

		newChildDescriptors.add
			(createChildParameter
				(FiacrePackage.eINSTANCE.getExistsProperty_Child(),
				 FiacreFactory.eINSTANCE.createExistsProperty()));

		newChildDescriptors.add
			(createChildParameter
				(FiacrePackage.eINSTANCE.getExistsProperty_Child(),
				 FiacreFactory.eINSTANCE.createPropertyDisjunction()));

		newChildDescriptors.add
			(createChildParameter
				(FiacrePackage.eINSTANCE.getExistsProperty_Child(),
				 FiacreFactory.eINSTANCE.createPropertyImplication()));

		newChildDescriptors.add
			(createChildParameter
				(FiacrePackage.eINSTANCE.getExistsProperty_Child(),
				 FiacreFactory.eINSTANCE.createPropertyConjunction()));

		newChildDescriptors.add
			(createChildParameter
				(FiacrePackage.eINSTANCE.getExistsProperty_Child(),
				 FiacreFactory.eINSTANCE.createPropertyNegation()));

		newChildDescriptors.add
			(createChildParameter
				(FiacrePackage.eINSTANCE.getExistsProperty_Child(),
				 FiacreFactory.eINSTANCE.createLeadsToPattern()));

		newChildDescriptors.add
			(createChildParameter
				(FiacrePackage.eINSTANCE.getExistsProperty_Child(),
				 FiacreFactory.eINSTANCE.createPrecedesPattern()));

		newChildDescriptors.add
			(createChildParameter
				(FiacrePackage.eINSTANCE.getExistsProperty_Child(),
				 FiacreFactory.eINSTANCE.createObservableDisjunction()));

		newChildDescriptors.add
			(createChildParameter
				(FiacrePackage.eINSTANCE.getExistsProperty_Child(),
				 FiacreFactory.eINSTANCE.createObservableImplication()));

		newChildDescriptors.add
			(createChildParameter
				(FiacrePackage.eINSTANCE.getExistsProperty_Child(),
				 FiacreFactory.eINSTANCE.createObservableConjunction()));

		newChildDescriptors.add
			(createChildParameter
				(FiacrePackage.eINSTANCE.getExistsProperty_Child(),
				 FiacreFactory.eINSTANCE.createObservableNegation()));
	}

}
