/*******************************************************************************
 * Copyright (c) 2015, 2016 CNRS, IRIT, IRT AESE (IRT Saint Exupéry).
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the LGPL 3.0
 * which accompanies this distribution, and is available at
 * https://www.gnu.org/licenses/lgpl-3.0-standalone.html
 *
 * Contributors:
 *      Faiez Zalila - initial API and implementation and/or initial documentation
 *******************************************************************************/
/**
 * generated by Xtext 2.10.0
 */
package fr.irit.fiacre.xtext.fiacre.provider;


import fr.irit.fiacre.xtext.fiacre.FiacreFactory;
import fr.irit.fiacre.xtext.fiacre.FiacrePackage;
import fr.irit.fiacre.xtext.fiacre.ParameterDeclaration;

import java.util.Collection;
import java.util.List;

import org.eclipse.emf.common.notify.AdapterFactory;
import org.eclipse.emf.common.notify.Notification;

import org.eclipse.emf.ecore.EStructuralFeature;

import org.eclipse.emf.edit.provider.ComposeableAdapterFactory;
import org.eclipse.emf.edit.provider.IItemPropertyDescriptor;
import org.eclipse.emf.edit.provider.ItemPropertyDescriptor;
import org.eclipse.emf.edit.provider.ViewerNotification;

/**
 * This is the item provider adapter for a {@link fr.irit.fiacre.xtext.fiacre.ParameterDeclaration} object.
 * <!-- begin-user-doc -->
 * <!-- end-user-doc -->
 * @generated
 */
public class ParameterDeclarationItemProvider extends NamedElementItemProvider {
	/**
	 * This constructs an instance from a factory and a notifier.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ParameterDeclarationItemProvider(AdapterFactory adapterFactory) {
		super(adapterFactory);
	}

	/**
	 * This returns the property descriptors for the adapted class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public List<IItemPropertyDescriptor> getPropertyDescriptors(Object object) {
		if (itemPropertyDescriptors == null) {
			super.getPropertyDescriptors(object);

			addReferencePropertyDescriptor(object);
			addArrayPropertyDescriptor(object);
		}
		return itemPropertyDescriptors;
	}

	/**
	 * This adds a property descriptor for the Reference feature.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected void addReferencePropertyDescriptor(Object object) {
		itemPropertyDescriptors.add
			(createItemPropertyDescriptor
				(((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
				 getResourceLocator(),
				 getString("_UI_ParameterDeclaration_reference_feature"),
				 getString("_UI_PropertyDescriptor_description", "_UI_ParameterDeclaration_reference_feature", "_UI_ParameterDeclaration_type"),
				 FiacrePackage.eINSTANCE.getParameterDeclaration_Reference(),
				 true,
				 false,
				 false,
				 ItemPropertyDescriptor.BOOLEAN_VALUE_IMAGE,
				 null,
				 null));
	}

	/**
	 * This adds a property descriptor for the Array feature.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected void addArrayPropertyDescriptor(Object object) {
		itemPropertyDescriptors.add
			(createItemPropertyDescriptor
				(((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
				 getResourceLocator(),
				 getString("_UI_ParameterDeclaration_array_feature"),
				 getString("_UI_PropertyDescriptor_description", "_UI_ParameterDeclaration_array_feature", "_UI_ParameterDeclaration_type"),
				 FiacrePackage.eINSTANCE.getParameterDeclaration_Array(),
				 true,
				 false,
				 false,
				 ItemPropertyDescriptor.BOOLEAN_VALUE_IMAGE,
				 null,
				 null));
	}

	/**
	 * This specifies how to implement {@link #getChildren} and is used to deduce an appropriate feature for an
	 * {@link org.eclipse.emf.edit.command.AddCommand}, {@link org.eclipse.emf.edit.command.RemoveCommand} or
	 * {@link org.eclipse.emf.edit.command.MoveCommand} in {@link #createCommand}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Collection<? extends EStructuralFeature> getChildrenFeatures(Object object) {
		if (childrenFeatures == null) {
			super.getChildrenFeatures(object);
			childrenFeatures.add(FiacrePackage.eINSTANCE.getParameterDeclaration_Size());
		}
		return childrenFeatures;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EStructuralFeature getChildFeature(Object object, Object child) {
		// Check the type of the specified child object and return the proper feature to use for
		// adding (see {@link AddCommand}) it as a child.

		return super.getChildFeature(object, child);
	}

	/**
	 * This returns ParameterDeclaration.gif.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object getImage(Object object) {
		return overlayImage(object, getResourceLocator().getImage("full/obj16/ParameterDeclaration"));
	}

	/**
	 * This returns the label text for the adapted class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String getText(Object object) {
		String label = ((ParameterDeclaration)object).getName();
		return label == null || label.length() == 0 ?
			getString("_UI_ParameterDeclaration_type") :
			getString("_UI_ParameterDeclaration_type") + " " + label;
	}
	

	/**
	 * This handles model notifications by calling {@link #updateChildren} to update any cached
	 * children and by creating a viewer notification, which it passes to {@link #fireNotifyChanged}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void notifyChanged(Notification notification) {
		updateChildren(notification);

		switch (notification.getFeatureID(ParameterDeclaration.class)) {
			case FiacrePackage.PARAMETER_DECLARATION__REFERENCE:
			case FiacrePackage.PARAMETER_DECLARATION__ARRAY:
				fireNotifyChanged(new ViewerNotification(notification, notification.getNotifier(), false, true));
				return;
			case FiacrePackage.PARAMETER_DECLARATION__SIZE:
				fireNotifyChanged(new ViewerNotification(notification, notification.getNotifier(), true, false));
				return;
		}
		super.notifyChanged(notification);
	}

	/**
	 * This adds {@link org.eclipse.emf.edit.command.CommandParameter}s describing the children
	 * that can be created under this object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected void collectNewChildDescriptors(Collection<Object> newChildDescriptors, Object object) {
		super.collectNewChildDescriptors(newChildDescriptors, object);

		newChildDescriptors.add
			(createChildParameter
				(FiacrePackage.eINSTANCE.getParameterDeclaration_Size(),
				 FiacreFactory.eINSTANCE.createExpression()));

		newChildDescriptors.add
			(createChildParameter
				(FiacrePackage.eINSTANCE.getParameterDeclaration_Size(),
				 FiacreFactory.eINSTANCE.createReferenceExpression()));

		newChildDescriptors.add
			(createChildParameter
				(FiacrePackage.eINSTANCE.getParameterDeclaration_Size(),
				 FiacreFactory.eINSTANCE.createIdentifierExpression()));

		newChildDescriptors.add
			(createChildParameter
				(FiacrePackage.eINSTANCE.getParameterDeclaration_Size(),
				 FiacreFactory.eINSTANCE.createRecordExpression()));

		newChildDescriptors.add
			(createChildParameter
				(FiacrePackage.eINSTANCE.getParameterDeclaration_Size(),
				 FiacreFactory.eINSTANCE.createArrayExpression()));

		newChildDescriptors.add
			(createChildParameter
				(FiacrePackage.eINSTANCE.getParameterDeclaration_Size(),
				 FiacreFactory.eINSTANCE.createQueueExpression()));

		newChildDescriptors.add
			(createChildParameter
				(FiacrePackage.eINSTANCE.getParameterDeclaration_Size(),
				 FiacreFactory.eINSTANCE.createEnqueueExpression()));

		newChildDescriptors.add
			(createChildParameter
				(FiacrePackage.eINSTANCE.getParameterDeclaration_Size(),
				 FiacreFactory.eINSTANCE.createAppendExpression()));

		newChildDescriptors.add
			(createChildParameter
				(FiacrePackage.eINSTANCE.getParameterDeclaration_Size(),
				 FiacreFactory.eINSTANCE.createLiteralExpression()));

		newChildDescriptors.add
			(createChildParameter
				(FiacrePackage.eINSTANCE.getParameterDeclaration_Size(),
				 FiacreFactory.eINSTANCE.createBooleanLiteral()));

		newChildDescriptors.add
			(createChildParameter
				(FiacrePackage.eINSTANCE.getParameterDeclaration_Size(),
				 FiacreFactory.eINSTANCE.createNaturalLiteral()));

		newChildDescriptors.add
			(createChildParameter
				(FiacrePackage.eINSTANCE.getParameterDeclaration_Size(),
				 FiacreFactory.eINSTANCE.createAllExpression()));

		newChildDescriptors.add
			(createChildParameter
				(FiacrePackage.eINSTANCE.getParameterDeclaration_Size(),
				 FiacreFactory.eINSTANCE.createExistsExpression()));

		newChildDescriptors.add
			(createChildParameter
				(FiacrePackage.eINSTANCE.getParameterDeclaration_Size(),
				 FiacreFactory.eINSTANCE.createConditional()));

		newChildDescriptors.add
			(createChildParameter
				(FiacrePackage.eINSTANCE.getParameterDeclaration_Size(),
				 FiacreFactory.eINSTANCE.createDisjunction()));

		newChildDescriptors.add
			(createChildParameter
				(FiacrePackage.eINSTANCE.getParameterDeclaration_Size(),
				 FiacreFactory.eINSTANCE.createImplication()));

		newChildDescriptors.add
			(createChildParameter
				(FiacrePackage.eINSTANCE.getParameterDeclaration_Size(),
				 FiacreFactory.eINSTANCE.createConjunction()));

		newChildDescriptors.add
			(createChildParameter
				(FiacrePackage.eINSTANCE.getParameterDeclaration_Size(),
				 FiacreFactory.eINSTANCE.createComparisonEqual()));

		newChildDescriptors.add
			(createChildParameter
				(FiacrePackage.eINSTANCE.getParameterDeclaration_Size(),
				 FiacreFactory.eINSTANCE.createComparisonNotEqual()));

		newChildDescriptors.add
			(createChildParameter
				(FiacrePackage.eINSTANCE.getParameterDeclaration_Size(),
				 FiacreFactory.eINSTANCE.createComparisonLesser()));

		newChildDescriptors.add
			(createChildParameter
				(FiacrePackage.eINSTANCE.getParameterDeclaration_Size(),
				 FiacreFactory.eINSTANCE.createComparisonLesserEqual()));

		newChildDescriptors.add
			(createChildParameter
				(FiacrePackage.eINSTANCE.getParameterDeclaration_Size(),
				 FiacreFactory.eINSTANCE.createComparisonGreater()));

		newChildDescriptors.add
			(createChildParameter
				(FiacrePackage.eINSTANCE.getParameterDeclaration_Size(),
				 FiacreFactory.eINSTANCE.createComparisonGreaterEqual()));

		newChildDescriptors.add
			(createChildParameter
				(FiacrePackage.eINSTANCE.getParameterDeclaration_Size(),
				 FiacreFactory.eINSTANCE.createAddition()));

		newChildDescriptors.add
			(createChildParameter
				(FiacrePackage.eINSTANCE.getParameterDeclaration_Size(),
				 FiacreFactory.eINSTANCE.createSubstraction()));

		newChildDescriptors.add
			(createChildParameter
				(FiacrePackage.eINSTANCE.getParameterDeclaration_Size(),
				 FiacreFactory.eINSTANCE.createMultiplication()));

		newChildDescriptors.add
			(createChildParameter
				(FiacrePackage.eINSTANCE.getParameterDeclaration_Size(),
				 FiacreFactory.eINSTANCE.createDivision()));

		newChildDescriptors.add
			(createChildParameter
				(FiacrePackage.eINSTANCE.getParameterDeclaration_Size(),
				 FiacreFactory.eINSTANCE.createModulo()));

		newChildDescriptors.add
			(createChildParameter
				(FiacrePackage.eINSTANCE.getParameterDeclaration_Size(),
				 FiacreFactory.eINSTANCE.createUnaryPlusExpression()));

		newChildDescriptors.add
			(createChildParameter
				(FiacrePackage.eINSTANCE.getParameterDeclaration_Size(),
				 FiacreFactory.eINSTANCE.createUnaryMinusExpression()));

		newChildDescriptors.add
			(createChildParameter
				(FiacrePackage.eINSTANCE.getParameterDeclaration_Size(),
				 FiacreFactory.eINSTANCE.createUnaryNegationExpression()));

		newChildDescriptors.add
			(createChildParameter
				(FiacrePackage.eINSTANCE.getParameterDeclaration_Size(),
				 FiacreFactory.eINSTANCE.createUnaryFirstExpression()));

		newChildDescriptors.add
			(createChildParameter
				(FiacrePackage.eINSTANCE.getParameterDeclaration_Size(),
				 FiacreFactory.eINSTANCE.createUnaryLengthExpression()));

		newChildDescriptors.add
			(createChildParameter
				(FiacrePackage.eINSTANCE.getParameterDeclaration_Size(),
				 FiacreFactory.eINSTANCE.createUnaryCoerceExpression()));

		newChildDescriptors.add
			(createChildParameter
				(FiacrePackage.eINSTANCE.getParameterDeclaration_Size(),
				 FiacreFactory.eINSTANCE.createUnaryFullExpression()));

		newChildDescriptors.add
			(createChildParameter
				(FiacrePackage.eINSTANCE.getParameterDeclaration_Size(),
				 FiacreFactory.eINSTANCE.createUnaryDeQueueExpression()));

		newChildDescriptors.add
			(createChildParameter
				(FiacrePackage.eINSTANCE.getParameterDeclaration_Size(),
				 FiacreFactory.eINSTANCE.createUnaryEmptyExpression()));

		newChildDescriptors.add
			(createChildParameter
				(FiacrePackage.eINSTANCE.getParameterDeclaration_Size(),
				 FiacreFactory.eINSTANCE.createProjection()));

		newChildDescriptors.add
			(createChildParameter
				(FiacrePackage.eINSTANCE.getParameterDeclaration_Size(),
				 FiacreFactory.eINSTANCE.createConstructionExpression()));

		newChildDescriptors.add
			(createChildParameter
				(FiacrePackage.eINSTANCE.getParameterDeclaration_Size(),
				 FiacreFactory.eINSTANCE.createArrayAccessExpression()));

		newChildDescriptors.add
			(createChildParameter
				(FiacrePackage.eINSTANCE.getParameterDeclaration_Size(),
				 FiacreFactory.eINSTANCE.createRecordAccessExpression()));

		newChildDescriptors.add
			(createChildParameter
				(FiacrePackage.eINSTANCE.getParameterDeclaration_Size(),
				 FiacreFactory.eINSTANCE.createTrueLiteral()));

		newChildDescriptors.add
			(createChildParameter
				(FiacrePackage.eINSTANCE.getParameterDeclaration_Size(),
				 FiacreFactory.eINSTANCE.createFalseLiteral()));
	}

}
