/*******************************************************************************
 * Copyright (c) 2015, 2016 CNRS, IRIT, IRT AESE (IRT Saint Exupéry).
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the LGPL 3.0
 * which accompanies this distribution, and is available at
 * https://www.gnu.org/licenses/lgpl-3.0-standalone.html
 *
 * Contributors:
 *      Faiez Zalila - initial API and implementation and/or initial documentation
 *******************************************************************************/
/**
 * generated by Xtext 2.10.0
 */
package fr.irit.fiacre.xtext.fiacre.provider;


import fr.irit.fiacre.xtext.fiacre.FiacreFactory;
import fr.irit.fiacre.xtext.fiacre.FiacrePackage;
import fr.irit.fiacre.xtext.fiacre.PortSet;

import java.util.Collection;
import java.util.List;

import org.eclipse.emf.common.notify.AdapterFactory;
import org.eclipse.emf.common.notify.Notification;

import org.eclipse.emf.common.util.ResourceLocator;

import org.eclipse.emf.ecore.EStructuralFeature;

import org.eclipse.emf.edit.provider.ComposeableAdapterFactory;
import org.eclipse.emf.edit.provider.IEditingDomainItemProvider;
import org.eclipse.emf.edit.provider.IItemLabelProvider;
import org.eclipse.emf.edit.provider.IItemPropertyDescriptor;
import org.eclipse.emf.edit.provider.IItemPropertySource;
import org.eclipse.emf.edit.provider.IStructuredItemContentProvider;
import org.eclipse.emf.edit.provider.ITreeItemContentProvider;
import org.eclipse.emf.edit.provider.ItemPropertyDescriptor;
import org.eclipse.emf.edit.provider.ItemProviderAdapter;
import org.eclipse.emf.edit.provider.ViewerNotification;

/**
 * This is the item provider adapter for a {@link fr.irit.fiacre.xtext.fiacre.PortSet} object.
 * <!-- begin-user-doc -->
 * <!-- end-user-doc -->
 * @generated
 */
public class PortSetItemProvider 
	extends ItemProviderAdapter
	implements
		IEditingDomainItemProvider,
		IStructuredItemContentProvider,
		ITreeItemContentProvider,
		IItemLabelProvider,
		IItemPropertySource {
	/**
	 * This constructs an instance from a factory and a notifier.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public PortSetItemProvider(AdapterFactory adapterFactory) {
		super(adapterFactory);
	}

	/**
	 * This returns the property descriptors for the adapted class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public List<IItemPropertyDescriptor> getPropertyDescriptors(Object object) {
		if (itemPropertyDescriptors == null) {
			super.getPropertyDescriptors(object);

			addAllPortsPropertyDescriptor(object);
		}
		return itemPropertyDescriptors;
	}

	/**
	 * This adds a property descriptor for the All Ports feature.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected void addAllPortsPropertyDescriptor(Object object) {
		itemPropertyDescriptors.add
			(createItemPropertyDescriptor
				(((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
				 getResourceLocator(),
				 getString("_UI_PortSet_allPorts_feature"),
				 getString("_UI_PropertyDescriptor_description", "_UI_PortSet_allPorts_feature", "_UI_PortSet_type"),
				 FiacrePackage.eINSTANCE.getPortSet_AllPorts(),
				 true,
				 false,
				 false,
				 ItemPropertyDescriptor.BOOLEAN_VALUE_IMAGE,
				 null,
				 null));
	}

	/**
	 * This specifies how to implement {@link #getChildren} and is used to deduce an appropriate feature for an
	 * {@link org.eclipse.emf.edit.command.AddCommand}, {@link org.eclipse.emf.edit.command.RemoveCommand} or
	 * {@link org.eclipse.emf.edit.command.MoveCommand} in {@link #createCommand}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Collection<? extends EStructuralFeature> getChildrenFeatures(Object object) {
		if (childrenFeatures == null) {
			super.getChildrenFeatures(object);
			childrenFeatures.add(FiacrePackage.eINSTANCE.getPortSet_Ports());
		}
		return childrenFeatures;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EStructuralFeature getChildFeature(Object object, Object child) {
		// Check the type of the specified child object and return the proper feature to use for
		// adding (see {@link AddCommand}) it as a child.

		return super.getChildFeature(object, child);
	}

	/**
	 * This returns PortSet.gif.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object getImage(Object object) {
		return overlayImage(object, getResourceLocator().getImage("full/obj16/PortSet"));
	}

	/**
	 * This returns the label text for the adapted class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String getText(Object object) {
		PortSet portSet = (PortSet)object;
		return getString("_UI_PortSet_type") + " " + portSet.isAllPorts();
	}
	

	/**
	 * This handles model notifications by calling {@link #updateChildren} to update any cached
	 * children and by creating a viewer notification, which it passes to {@link #fireNotifyChanged}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void notifyChanged(Notification notification) {
		updateChildren(notification);

		switch (notification.getFeatureID(PortSet.class)) {
			case FiacrePackage.PORT_SET__ALL_PORTS:
				fireNotifyChanged(new ViewerNotification(notification, notification.getNotifier(), false, true));
				return;
			case FiacrePackage.PORT_SET__PORTS:
				fireNotifyChanged(new ViewerNotification(notification, notification.getNotifier(), true, false));
				return;
		}
		super.notifyChanged(notification);
	}

	/**
	 * This adds {@link org.eclipse.emf.edit.command.CommandParameter}s describing the children
	 * that can be created under this object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected void collectNewChildDescriptors(Collection<Object> newChildDescriptors, Object object) {
		super.collectNewChildDescriptors(newChildDescriptors, object);

		newChildDescriptors.add
			(createChildParameter
				(FiacrePackage.eINSTANCE.getPortSet_Ports(),
				 FiacreFactory.eINSTANCE.createExpression()));

		newChildDescriptors.add
			(createChildParameter
				(FiacrePackage.eINSTANCE.getPortSet_Ports(),
				 FiacreFactory.eINSTANCE.createReferenceExpression()));

		newChildDescriptors.add
			(createChildParameter
				(FiacrePackage.eINSTANCE.getPortSet_Ports(),
				 FiacreFactory.eINSTANCE.createIdentifierExpression()));

		newChildDescriptors.add
			(createChildParameter
				(FiacrePackage.eINSTANCE.getPortSet_Ports(),
				 FiacreFactory.eINSTANCE.createRecordExpression()));

		newChildDescriptors.add
			(createChildParameter
				(FiacrePackage.eINSTANCE.getPortSet_Ports(),
				 FiacreFactory.eINSTANCE.createArrayExpression()));

		newChildDescriptors.add
			(createChildParameter
				(FiacrePackage.eINSTANCE.getPortSet_Ports(),
				 FiacreFactory.eINSTANCE.createQueueExpression()));

		newChildDescriptors.add
			(createChildParameter
				(FiacrePackage.eINSTANCE.getPortSet_Ports(),
				 FiacreFactory.eINSTANCE.createEnqueueExpression()));

		newChildDescriptors.add
			(createChildParameter
				(FiacrePackage.eINSTANCE.getPortSet_Ports(),
				 FiacreFactory.eINSTANCE.createAppendExpression()));

		newChildDescriptors.add
			(createChildParameter
				(FiacrePackage.eINSTANCE.getPortSet_Ports(),
				 FiacreFactory.eINSTANCE.createLiteralExpression()));

		newChildDescriptors.add
			(createChildParameter
				(FiacrePackage.eINSTANCE.getPortSet_Ports(),
				 FiacreFactory.eINSTANCE.createBooleanLiteral()));

		newChildDescriptors.add
			(createChildParameter
				(FiacrePackage.eINSTANCE.getPortSet_Ports(),
				 FiacreFactory.eINSTANCE.createNaturalLiteral()));

		newChildDescriptors.add
			(createChildParameter
				(FiacrePackage.eINSTANCE.getPortSet_Ports(),
				 FiacreFactory.eINSTANCE.createAllExpression()));

		newChildDescriptors.add
			(createChildParameter
				(FiacrePackage.eINSTANCE.getPortSet_Ports(),
				 FiacreFactory.eINSTANCE.createExistsExpression()));

		newChildDescriptors.add
			(createChildParameter
				(FiacrePackage.eINSTANCE.getPortSet_Ports(),
				 FiacreFactory.eINSTANCE.createConditional()));

		newChildDescriptors.add
			(createChildParameter
				(FiacrePackage.eINSTANCE.getPortSet_Ports(),
				 FiacreFactory.eINSTANCE.createDisjunction()));

		newChildDescriptors.add
			(createChildParameter
				(FiacrePackage.eINSTANCE.getPortSet_Ports(),
				 FiacreFactory.eINSTANCE.createImplication()));

		newChildDescriptors.add
			(createChildParameter
				(FiacrePackage.eINSTANCE.getPortSet_Ports(),
				 FiacreFactory.eINSTANCE.createConjunction()));

		newChildDescriptors.add
			(createChildParameter
				(FiacrePackage.eINSTANCE.getPortSet_Ports(),
				 FiacreFactory.eINSTANCE.createComparisonEqual()));

		newChildDescriptors.add
			(createChildParameter
				(FiacrePackage.eINSTANCE.getPortSet_Ports(),
				 FiacreFactory.eINSTANCE.createComparisonNotEqual()));

		newChildDescriptors.add
			(createChildParameter
				(FiacrePackage.eINSTANCE.getPortSet_Ports(),
				 FiacreFactory.eINSTANCE.createComparisonLesser()));

		newChildDescriptors.add
			(createChildParameter
				(FiacrePackage.eINSTANCE.getPortSet_Ports(),
				 FiacreFactory.eINSTANCE.createComparisonLesserEqual()));

		newChildDescriptors.add
			(createChildParameter
				(FiacrePackage.eINSTANCE.getPortSet_Ports(),
				 FiacreFactory.eINSTANCE.createComparisonGreater()));

		newChildDescriptors.add
			(createChildParameter
				(FiacrePackage.eINSTANCE.getPortSet_Ports(),
				 FiacreFactory.eINSTANCE.createComparisonGreaterEqual()));

		newChildDescriptors.add
			(createChildParameter
				(FiacrePackage.eINSTANCE.getPortSet_Ports(),
				 FiacreFactory.eINSTANCE.createAddition()));

		newChildDescriptors.add
			(createChildParameter
				(FiacrePackage.eINSTANCE.getPortSet_Ports(),
				 FiacreFactory.eINSTANCE.createSubstraction()));

		newChildDescriptors.add
			(createChildParameter
				(FiacrePackage.eINSTANCE.getPortSet_Ports(),
				 FiacreFactory.eINSTANCE.createMultiplication()));

		newChildDescriptors.add
			(createChildParameter
				(FiacrePackage.eINSTANCE.getPortSet_Ports(),
				 FiacreFactory.eINSTANCE.createDivision()));

		newChildDescriptors.add
			(createChildParameter
				(FiacrePackage.eINSTANCE.getPortSet_Ports(),
				 FiacreFactory.eINSTANCE.createModulo()));

		newChildDescriptors.add
			(createChildParameter
				(FiacrePackage.eINSTANCE.getPortSet_Ports(),
				 FiacreFactory.eINSTANCE.createUnaryPlusExpression()));

		newChildDescriptors.add
			(createChildParameter
				(FiacrePackage.eINSTANCE.getPortSet_Ports(),
				 FiacreFactory.eINSTANCE.createUnaryMinusExpression()));

		newChildDescriptors.add
			(createChildParameter
				(FiacrePackage.eINSTANCE.getPortSet_Ports(),
				 FiacreFactory.eINSTANCE.createUnaryNegationExpression()));

		newChildDescriptors.add
			(createChildParameter
				(FiacrePackage.eINSTANCE.getPortSet_Ports(),
				 FiacreFactory.eINSTANCE.createUnaryFirstExpression()));

		newChildDescriptors.add
			(createChildParameter
				(FiacrePackage.eINSTANCE.getPortSet_Ports(),
				 FiacreFactory.eINSTANCE.createUnaryLengthExpression()));

		newChildDescriptors.add
			(createChildParameter
				(FiacrePackage.eINSTANCE.getPortSet_Ports(),
				 FiacreFactory.eINSTANCE.createUnaryCoerceExpression()));

		newChildDescriptors.add
			(createChildParameter
				(FiacrePackage.eINSTANCE.getPortSet_Ports(),
				 FiacreFactory.eINSTANCE.createUnaryFullExpression()));

		newChildDescriptors.add
			(createChildParameter
				(FiacrePackage.eINSTANCE.getPortSet_Ports(),
				 FiacreFactory.eINSTANCE.createUnaryDeQueueExpression()));

		newChildDescriptors.add
			(createChildParameter
				(FiacrePackage.eINSTANCE.getPortSet_Ports(),
				 FiacreFactory.eINSTANCE.createUnaryEmptyExpression()));

		newChildDescriptors.add
			(createChildParameter
				(FiacrePackage.eINSTANCE.getPortSet_Ports(),
				 FiacreFactory.eINSTANCE.createProjection()));

		newChildDescriptors.add
			(createChildParameter
				(FiacrePackage.eINSTANCE.getPortSet_Ports(),
				 FiacreFactory.eINSTANCE.createConstructionExpression()));

		newChildDescriptors.add
			(createChildParameter
				(FiacrePackage.eINSTANCE.getPortSet_Ports(),
				 FiacreFactory.eINSTANCE.createArrayAccessExpression()));

		newChildDescriptors.add
			(createChildParameter
				(FiacrePackage.eINSTANCE.getPortSet_Ports(),
				 FiacreFactory.eINSTANCE.createRecordAccessExpression()));

		newChildDescriptors.add
			(createChildParameter
				(FiacrePackage.eINSTANCE.getPortSet_Ports(),
				 FiacreFactory.eINSTANCE.createTrueLiteral()));

		newChildDescriptors.add
			(createChildParameter
				(FiacrePackage.eINSTANCE.getPortSet_Ports(),
				 FiacreFactory.eINSTANCE.createFalseLiteral()));
	}

	/**
	 * Return the resource locator for this item provider's resources.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public ResourceLocator getResourceLocator() {
		return FiacreEditPlugin.INSTANCE;
	}

}
