/*******************************************************************************
 * Copyright (c) 2015, 2016 CNRS, IRIT, IRT AESE (IRT Saint Exupéry).
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the LGPL 3.0
 * which accompanies this distribution, and is available at
 * https://www.gnu.org/licenses/lgpl-3.0-standalone.html
 *
 * Contributors:
 *      Faiez Zalila - initial API and implementation and/or initial documentation
 *******************************************************************************/
/**
 * generated by Xtext 2.10.0
 */
package fr.irit.fiacre.xtext.fiacre.provider;


import fr.irit.fiacre.xtext.fiacre.FiacreFactory;
import fr.irit.fiacre.xtext.fiacre.FiacrePackage;
import fr.irit.fiacre.xtext.fiacre.ProcessDeclaration;

import java.util.Collection;
import java.util.List;

import org.eclipse.emf.common.notify.AdapterFactory;
import org.eclipse.emf.common.notify.Notification;

import org.eclipse.emf.ecore.EStructuralFeature;

import org.eclipse.emf.edit.provider.ComposeableAdapterFactory;
import org.eclipse.emf.edit.provider.IItemPropertyDescriptor;
import org.eclipse.emf.edit.provider.ItemPropertyDescriptor;
import org.eclipse.emf.edit.provider.ViewerNotification;

/**
 * This is the item provider adapter for a {@link fr.irit.fiacre.xtext.fiacre.ProcessDeclaration} object.
 * <!-- begin-user-doc -->
 * <!-- end-user-doc -->
 * @generated
 */
public class ProcessDeclarationItemProvider extends RootDeclarationItemProvider {
	/**
	 * This constructs an instance from a factory and a notifier.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ProcessDeclarationItemProvider(AdapterFactory adapterFactory) {
		super(adapterFactory);
	}

	/**
	 * This returns the property descriptors for the adapted class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public List<IItemPropertyDescriptor> getPropertyDescriptors(Object object) {
		if (itemPropertyDescriptors == null) {
			super.getPropertyDescriptors(object);

			addNamePropertyDescriptor(object);
		}
		return itemPropertyDescriptors;
	}

	/**
	 * This adds a property descriptor for the Name feature.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected void addNamePropertyDescriptor(Object object) {
		itemPropertyDescriptors.add
			(createItemPropertyDescriptor
				(((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
				 getResourceLocator(),
				 getString("_UI_NamedElement_name_feature"),
				 getString("_UI_PropertyDescriptor_description", "_UI_NamedElement_name_feature", "_UI_NamedElement_type"),
				 FiacrePackage.eINSTANCE.getNamedElement_Name(),
				 true,
				 false,
				 false,
				 ItemPropertyDescriptor.GENERIC_VALUE_IMAGE,
				 null,
				 null));
	}

	/**
	 * This specifies how to implement {@link #getChildren} and is used to deduce an appropriate feature for an
	 * {@link org.eclipse.emf.edit.command.AddCommand}, {@link org.eclipse.emf.edit.command.RemoveCommand} or
	 * {@link org.eclipse.emf.edit.command.MoveCommand} in {@link #createCommand}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Collection<? extends EStructuralFeature> getChildrenFeatures(Object object) {
		if (childrenFeatures == null) {
			super.getChildrenFeatures(object);
			childrenFeatures.add(FiacrePackage.eINSTANCE.getParameterizedDeclaration_Parameters());
			childrenFeatures.add(FiacrePackage.eINSTANCE.getParameterizedDeclaration_Variables());
			childrenFeatures.add(FiacrePackage.eINSTANCE.getProcessDeclaration_Ports());
			childrenFeatures.add(FiacrePackage.eINSTANCE.getProcessDeclaration_LocalPorts());
			childrenFeatures.add(FiacrePackage.eINSTANCE.getProcessDeclaration_Priorities());
			childrenFeatures.add(FiacrePackage.eINSTANCE.getProcessDeclaration_States());
			childrenFeatures.add(FiacrePackage.eINSTANCE.getProcessDeclaration_Prelude());
			childrenFeatures.add(FiacrePackage.eINSTANCE.getProcessDeclaration_Transitions());
		}
		return childrenFeatures;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EStructuralFeature getChildFeature(Object object, Object child) {
		// Check the type of the specified child object and return the proper feature to use for
		// adding (see {@link AddCommand}) it as a child.

		return super.getChildFeature(object, child);
	}

	/**
	 * This returns ProcessDeclaration.gif.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object getImage(Object object) {
		return overlayImage(object, getResourceLocator().getImage("full/obj16/ProcessDeclaration"));
	}

	/**
	 * This returns the label text for the adapted class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String getText(Object object) {
		String label = ((ProcessDeclaration)object).getName();
		return label == null || label.length() == 0 ?
			getString("_UI_ProcessDeclaration_type") :
			getString("_UI_ProcessDeclaration_type") + " " + label;
	}
	

	/**
	 * This handles model notifications by calling {@link #updateChildren} to update any cached
	 * children and by creating a viewer notification, which it passes to {@link #fireNotifyChanged}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void notifyChanged(Notification notification) {
		updateChildren(notification);

		switch (notification.getFeatureID(ProcessDeclaration.class)) {
			case FiacrePackage.PROCESS_DECLARATION__NAME:
				fireNotifyChanged(new ViewerNotification(notification, notification.getNotifier(), false, true));
				return;
			case FiacrePackage.PROCESS_DECLARATION__PARAMETERS:
			case FiacrePackage.PROCESS_DECLARATION__VARIABLES:
			case FiacrePackage.PROCESS_DECLARATION__PORTS:
			case FiacrePackage.PROCESS_DECLARATION__LOCAL_PORTS:
			case FiacrePackage.PROCESS_DECLARATION__PRIORITIES:
			case FiacrePackage.PROCESS_DECLARATION__STATES:
			case FiacrePackage.PROCESS_DECLARATION__PRELUDE:
			case FiacrePackage.PROCESS_DECLARATION__TRANSITIONS:
				fireNotifyChanged(new ViewerNotification(notification, notification.getNotifier(), true, false));
				return;
		}
		super.notifyChanged(notification);
	}

	/**
	 * This adds {@link org.eclipse.emf.edit.command.CommandParameter}s describing the children
	 * that can be created under this object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected void collectNewChildDescriptors(Collection<Object> newChildDescriptors, Object object) {
		super.collectNewChildDescriptors(newChildDescriptors, object);

		newChildDescriptors.add
			(createChildParameter
				(FiacrePackage.eINSTANCE.getParameterizedDeclaration_Parameters(),
				 FiacreFactory.eINSTANCE.createParametersDeclaration()));

		newChildDescriptors.add
			(createChildParameter
				(FiacrePackage.eINSTANCE.getParameterizedDeclaration_Variables(),
				 FiacreFactory.eINSTANCE.createVariablesDeclaration()));

		newChildDescriptors.add
			(createChildParameter
				(FiacrePackage.eINSTANCE.getProcessDeclaration_Ports(),
				 FiacreFactory.eINSTANCE.createPortsDeclaration()));

		newChildDescriptors.add
			(createChildParameter
				(FiacrePackage.eINSTANCE.getProcessDeclaration_LocalPorts(),
				 FiacreFactory.eINSTANCE.createPortsDeclaration()));

		newChildDescriptors.add
			(createChildParameter
				(FiacrePackage.eINSTANCE.getProcessDeclaration_Priorities(),
				 FiacreFactory.eINSTANCE.createPriorityDeclaration()));

		newChildDescriptors.add
			(createChildParameter
				(FiacrePackage.eINSTANCE.getProcessDeclaration_States(),
				 FiacreFactory.eINSTANCE.createStateDeclaration()));

		newChildDescriptors.add
			(createChildParameter
				(FiacrePackage.eINSTANCE.getProcessDeclaration_Prelude(),
				 FiacreFactory.eINSTANCE.createStatement()));

		newChildDescriptors.add
			(createChildParameter
				(FiacrePackage.eINSTANCE.getProcessDeclaration_Prelude(),
				 FiacreFactory.eINSTANCE.createBlockStatement()));

		newChildDescriptors.add
			(createChildParameter
				(FiacrePackage.eINSTANCE.getProcessDeclaration_Prelude(),
				 FiacreFactory.eINSTANCE.createReturnStatement()));

		newChildDescriptors.add
			(createChildParameter
				(FiacrePackage.eINSTANCE.getProcessDeclaration_Prelude(),
				 FiacreFactory.eINSTANCE.createNullStatement()));

		newChildDescriptors.add
			(createChildParameter
				(FiacrePackage.eINSTANCE.getProcessDeclaration_Prelude(),
				 FiacreFactory.eINSTANCE.createTaggedStatement()));

		newChildDescriptors.add
			(createChildParameter
				(FiacrePackage.eINSTANCE.getProcessDeclaration_Prelude(),
				 FiacreFactory.eINSTANCE.createPatternStatement()));

		newChildDescriptors.add
			(createChildParameter
				(FiacrePackage.eINSTANCE.getProcessDeclaration_Prelude(),
				 FiacreFactory.eINSTANCE.createPattern()));

		newChildDescriptors.add
			(createChildParameter
				(FiacrePackage.eINSTANCE.getProcessDeclaration_Prelude(),
				 FiacreFactory.eINSTANCE.createAnyPattern()));

		newChildDescriptors.add
			(createChildParameter
				(FiacrePackage.eINSTANCE.getProcessDeclaration_Prelude(),
				 FiacreFactory.eINSTANCE.createConstantPattern()));

		newChildDescriptors.add
			(createChildParameter
				(FiacrePackage.eINSTANCE.getProcessDeclaration_Prelude(),
				 FiacreFactory.eINSTANCE.createIntegerPattern()));

		newChildDescriptors.add
			(createChildParameter
				(FiacrePackage.eINSTANCE.getProcessDeclaration_Prelude(),
				 FiacreFactory.eINSTANCE.createIdentifierPattern()));

		newChildDescriptors.add
			(createChildParameter
				(FiacrePackage.eINSTANCE.getProcessDeclaration_Prelude(),
				 FiacreFactory.eINSTANCE.createConditionalStatement()));

		newChildDescriptors.add
			(createChildParameter
				(FiacrePackage.eINSTANCE.getProcessDeclaration_Prelude(),
				 FiacreFactory.eINSTANCE.createSelectStatement()));

		newChildDescriptors.add
			(createChildParameter
				(FiacrePackage.eINSTANCE.getProcessDeclaration_Prelude(),
				 FiacreFactory.eINSTANCE.createWhileStatement()));

		newChildDescriptors.add
			(createChildParameter
				(FiacrePackage.eINSTANCE.getProcessDeclaration_Prelude(),
				 FiacreFactory.eINSTANCE.createForeachStatement()));

		newChildDescriptors.add
			(createChildParameter
				(FiacrePackage.eINSTANCE.getProcessDeclaration_Prelude(),
				 FiacreFactory.eINSTANCE.createToStatement()));

		newChildDescriptors.add
			(createChildParameter
				(FiacrePackage.eINSTANCE.getProcessDeclaration_Prelude(),
				 FiacreFactory.eINSTANCE.createCaseStatement()));

		newChildDescriptors.add
			(createChildParameter
				(FiacrePackage.eINSTANCE.getProcessDeclaration_Prelude(),
				 FiacreFactory.eINSTANCE.createLoopStatement()));

		newChildDescriptors.add
			(createChildParameter
				(FiacrePackage.eINSTANCE.getProcessDeclaration_Prelude(),
				 FiacreFactory.eINSTANCE.createOnStatement()));

		newChildDescriptors.add
			(createChildParameter
				(FiacrePackage.eINSTANCE.getProcessDeclaration_Prelude(),
				 FiacreFactory.eINSTANCE.createWaitStatement()));

		newChildDescriptors.add
			(createChildParameter
				(FiacrePackage.eINSTANCE.getProcessDeclaration_Prelude(),
				 FiacreFactory.eINSTANCE.createUnlessStatement()));

		newChildDescriptors.add
			(createChildParameter
				(FiacrePackage.eINSTANCE.getProcessDeclaration_Prelude(),
				 FiacreFactory.eINSTANCE.createStatementChoice()));

		newChildDescriptors.add
			(createChildParameter
				(FiacrePackage.eINSTANCE.getProcessDeclaration_Prelude(),
				 FiacreFactory.eINSTANCE.createStatementSequence()));

		newChildDescriptors.add
			(createChildParameter
				(FiacrePackage.eINSTANCE.getProcessDeclaration_Prelude(),
				 FiacreFactory.eINSTANCE.createAssignStatement()));

		newChildDescriptors.add
			(createChildParameter
				(FiacrePackage.eINSTANCE.getProcessDeclaration_Prelude(),
				 FiacreFactory.eINSTANCE.createAssignAnyStatement()));

		newChildDescriptors.add
			(createChildParameter
				(FiacrePackage.eINSTANCE.getProcessDeclaration_Prelude(),
				 FiacreFactory.eINSTANCE.createSendStatement()));

		newChildDescriptors.add
			(createChildParameter
				(FiacrePackage.eINSTANCE.getProcessDeclaration_Prelude(),
				 FiacreFactory.eINSTANCE.createReceiveStatement()));

		newChildDescriptors.add
			(createChildParameter
				(FiacrePackage.eINSTANCE.getProcessDeclaration_Prelude(),
				 FiacreFactory.eINSTANCE.createConstructorPattern()));

		newChildDescriptors.add
			(createChildParameter
				(FiacrePackage.eINSTANCE.getProcessDeclaration_Prelude(),
				 FiacreFactory.eINSTANCE.createArrayAccessPattern()));

		newChildDescriptors.add
			(createChildParameter
				(FiacrePackage.eINSTANCE.getProcessDeclaration_Prelude(),
				 FiacreFactory.eINSTANCE.createRecordAccessPattern()));

		newChildDescriptors.add
			(createChildParameter
				(FiacrePackage.eINSTANCE.getProcessDeclaration_Transitions(),
				 FiacreFactory.eINSTANCE.createTransition()));
	}

	/**
	 * This returns the label text for {@link org.eclipse.emf.edit.command.CreateChildCommand}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String getCreateChildText(Object owner, Object feature, Object child, Collection<?> selection) {
		Object childFeature = feature;
		Object childObject = child;

		boolean qualify =
			childFeature == FiacrePackage.eINSTANCE.getProcessDeclaration_Ports() ||
			childFeature == FiacrePackage.eINSTANCE.getProcessDeclaration_LocalPorts();

		if (qualify) {
			return getString
				("_UI_CreateChild_text2",
				 new Object[] { getTypeText(childObject), getFeatureText(childFeature), getTypeText(owner) });
		}
		return super.getCreateChildText(owner, feature, child, selection);
	}

}
