/*******************************************************************************
 * Copyright (c) 2015, 2016 CNRS, IRIT, IRT AESE (IRT Saint Exupéry).
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the LGPL 3.0
 * which accompanies this distribution, and is available at
 * https://www.gnu.org/licenses/lgpl-3.0-standalone.html
 *
 * Contributors:
 *      Faiez Zalila - initial API and implementation and/or initial documentation
 *******************************************************************************/
/**
 * generated by Xtext 2.10.0
 */
package fr.irit.fiacre.xtext.fiacre.provider;


import fr.irit.fiacre.xtext.fiacre.FiacreFactory;
import fr.irit.fiacre.xtext.fiacre.FiacrePackage;
import fr.irit.fiacre.xtext.fiacre.TypeDeclaration;

import java.util.Collection;
import java.util.List;

import org.eclipse.emf.common.notify.AdapterFactory;
import org.eclipse.emf.common.notify.Notification;

import org.eclipse.emf.ecore.EStructuralFeature;

import org.eclipse.emf.edit.provider.ComposeableAdapterFactory;
import org.eclipse.emf.edit.provider.IItemPropertyDescriptor;
import org.eclipse.emf.edit.provider.ItemPropertyDescriptor;
import org.eclipse.emf.edit.provider.ViewerNotification;

/**
 * This is the item provider adapter for a {@link fr.irit.fiacre.xtext.fiacre.TypeDeclaration} object.
 * <!-- begin-user-doc -->
 * <!-- end-user-doc -->
 * @generated
 */
public class TypeDeclarationItemProvider extends TypeDeclarationUseItemProvider {
	/**
	 * This constructs an instance from a factory and a notifier.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public TypeDeclarationItemProvider(AdapterFactory adapterFactory) {
		super(adapterFactory);
	}

	/**
	 * This returns the property descriptors for the adapted class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public List<IItemPropertyDescriptor> getPropertyDescriptors(Object object) {
		if (itemPropertyDescriptors == null) {
			super.getPropertyDescriptors(object);

			addNamePropertyDescriptor(object);
		}
		return itemPropertyDescriptors;
	}

	/**
	 * This adds a property descriptor for the Name feature.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected void addNamePropertyDescriptor(Object object) {
		itemPropertyDescriptors.add
			(createItemPropertyDescriptor
				(((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
				 getResourceLocator(),
				 getString("_UI_NamedElement_name_feature"),
				 getString("_UI_PropertyDescriptor_description", "_UI_NamedElement_name_feature", "_UI_NamedElement_type"),
				 FiacrePackage.eINSTANCE.getNamedElement_Name(),
				 true,
				 false,
				 false,
				 ItemPropertyDescriptor.GENERIC_VALUE_IMAGE,
				 null,
				 null));
	}

	/**
	 * This specifies how to implement {@link #getChildren} and is used to deduce an appropriate feature for an
	 * {@link org.eclipse.emf.edit.command.AddCommand}, {@link org.eclipse.emf.edit.command.RemoveCommand} or
	 * {@link org.eclipse.emf.edit.command.MoveCommand} in {@link #createCommand}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Collection<? extends EStructuralFeature> getChildrenFeatures(Object object) {
		if (childrenFeatures == null) {
			super.getChildrenFeatures(object);
			childrenFeatures.add(FiacrePackage.eINSTANCE.getTypeDeclaration_Value());
		}
		return childrenFeatures;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EStructuralFeature getChildFeature(Object object, Object child) {
		// Check the type of the specified child object and return the proper feature to use for
		// adding (see {@link AddCommand}) it as a child.

		return super.getChildFeature(object, child);
	}

	/**
	 * This returns TypeDeclaration.gif.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object getImage(Object object) {
		return overlayImage(object, getResourceLocator().getImage("full/obj16/TypeDeclaration"));
	}

	/**
	 * This returns the label text for the adapted class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String getText(Object object) {
		String label = ((TypeDeclaration)object).getName();
		return label == null || label.length() == 0 ?
			getString("_UI_TypeDeclaration_type") :
			getString("_UI_TypeDeclaration_type") + " " + label;
	}
	

	/**
	 * This handles model notifications by calling {@link #updateChildren} to update any cached
	 * children and by creating a viewer notification, which it passes to {@link #fireNotifyChanged}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void notifyChanged(Notification notification) {
		updateChildren(notification);

		switch (notification.getFeatureID(TypeDeclaration.class)) {
			case FiacrePackage.TYPE_DECLARATION__NAME:
				fireNotifyChanged(new ViewerNotification(notification, notification.getNotifier(), false, true));
				return;
			case FiacrePackage.TYPE_DECLARATION__VALUE:
				fireNotifyChanged(new ViewerNotification(notification, notification.getNotifier(), true, false));
				return;
		}
		super.notifyChanged(notification);
	}

	/**
	 * This adds {@link org.eclipse.emf.edit.command.CommandParameter}s describing the children
	 * that can be created under this object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected void collectNewChildDescriptors(Collection<Object> newChildDescriptors, Object object) {
		super.collectNewChildDescriptors(newChildDescriptors, object);

		newChildDescriptors.add
			(createChildParameter
				(FiacrePackage.eINSTANCE.getTypeDeclaration_Value(),
				 FiacreFactory.eINSTANCE.createType()));

		newChildDescriptors.add
			(createChildParameter
				(FiacrePackage.eINSTANCE.getTypeDeclaration_Value(),
				 FiacreFactory.eINSTANCE.createBasicType()));

		newChildDescriptors.add
			(createChildParameter
				(FiacrePackage.eINSTANCE.getTypeDeclaration_Value(),
				 FiacreFactory.eINSTANCE.createRangeType()));

		newChildDescriptors.add
			(createChildParameter
				(FiacrePackage.eINSTANCE.getTypeDeclaration_Value(),
				 FiacreFactory.eINSTANCE.createUnionType()));

		newChildDescriptors.add
			(createChildParameter
				(FiacrePackage.eINSTANCE.getTypeDeclaration_Value(),
				 FiacreFactory.eINSTANCE.createRecordType()));

		newChildDescriptors.add
			(createChildParameter
				(FiacrePackage.eINSTANCE.getTypeDeclaration_Value(),
				 FiacreFactory.eINSTANCE.createQueueType()));

		newChildDescriptors.add
			(createChildParameter
				(FiacrePackage.eINSTANCE.getTypeDeclaration_Value(),
				 FiacreFactory.eINSTANCE.createArrayType()));

		newChildDescriptors.add
			(createChildParameter
				(FiacrePackage.eINSTANCE.getTypeDeclaration_Value(),
				 FiacreFactory.eINSTANCE.createReferencedType()));

		newChildDescriptors.add
			(createChildParameter
				(FiacrePackage.eINSTANCE.getTypeDeclaration_Value(),
				 FiacreFactory.eINSTANCE.createTupleType()));

		newChildDescriptors.add
			(createChildParameter
				(FiacrePackage.eINSTANCE.getTypeDeclaration_Value(),
				 FiacreFactory.eINSTANCE.createNaturalType()));

		newChildDescriptors.add
			(createChildParameter
				(FiacrePackage.eINSTANCE.getTypeDeclaration_Value(),
				 FiacreFactory.eINSTANCE.createIntegerType()));

		newChildDescriptors.add
			(createChildParameter
				(FiacrePackage.eINSTANCE.getTypeDeclaration_Value(),
				 FiacreFactory.eINSTANCE.createBooleanType()));
	}

}
